//                              --- OpenGL 1.0 ---

/**
 *  @def GL_VERSION_1_0
 *  @brief if defined, OpenGL 1.0 entry points are available
 *  @note This does not necessarily mean it is also supported.
 */
#ifndef GL_VERSION_1_0
#define GL_VERSION_1_0 1

/**
 *  @def GLEH_OPENGL_1_0
 *  @brief set if OpenGL 1.0 is supported
 */
#define GLEH_OPENGL_1_0 true

/* AttribMask */
#define GL_DEPTH_BUFFER_BIT                                         0x00000100 /**< @brief OpenGL 1.0 enum (attrib mask) */
#define GL_STENCIL_BUFFER_BIT                                       0x00000400 /**< @brief OpenGL 1.0 enum (attrib mask) */
#define GL_COLOR_BUFFER_BIT                                         0x00004000 /**< @brief OpenGL 1.0 enum (attrib mask) */
/* Boolean */
#define GL_FALSE                                                    0 /**< @brief OpenGL 1.0 enum (boolean) */
#define GL_TRUE                                                     1 /**< @brief OpenGL 1.0 enum (boolean) */
/* BeginMode */
#define GL_POINTS                                                   0x0000 /**< @brief OpenGL 1.0 enum (begin mode) */
#define GL_LINES                                                    0x0001 /**< @brief OpenGL 1.0 enum (begin mode) */
#define GL_LINE_LOOP                                                0x0002 /**< @brief OpenGL 1.0 enum (begin mode) */
#define GL_LINE_STRIP                                               0x0003 /**< @brief OpenGL 1.0 enum (begin mode) */
#define GL_TRIANGLES                                                0x0004 /**< @brief OpenGL 1.0 enum (begin mode) */
#define GL_TRIANGLE_STRIP                                           0x0005 /**< @brief OpenGL 1.0 enum (begin mode) */
#define GL_TRIANGLE_FAN                                             0x0006 /**< @brief OpenGL 1.0 enum (begin mode) */
/* AlphaFunction */
#define GL_NEVER                                                    0x0200 /**< @brief OpenGL 1.0 enum (alpha function) */
#define GL_LESS                                                     0x0201 /**< @brief OpenGL 1.0 enum (alpha function) */
#define GL_EQUAL                                                    0x0202 /**< @brief OpenGL 1.0 enum (alpha function) */
#define GL_LEQUAL                                                   0x0203 /**< @brief OpenGL 1.0 enum (alpha function) */
#define GL_GREATER                                                  0x0204 /**< @brief OpenGL 1.0 enum (alpha function) */
#define GL_NOTEQUAL                                                 0x0205 /**< @brief OpenGL 1.0 enum (alpha function) */
#define GL_GEQUAL                                                   0x0206 /**< @brief OpenGL 1.0 enum (alpha function) */
#define GL_ALWAYS                                                   0x0207 /**< @brief OpenGL 1.0 enum (alpha function) */
/* BlendingFactorDest */
#define GL_ZERO                                                     0 /**< @brief OpenGL 1.0 enum (blending factor dest) */
#define GL_ONE                                                      1 /**< @brief OpenGL 1.0 enum (blending factor dest) */
#define GL_SRC_COLOR                                                0x0300 /**< @brief OpenGL 1.0 enum (blending factor dest) */
#define GL_ONE_MINUS_SRC_COLOR                                      0x0301 /**< @brief OpenGL 1.0 enum (blending factor dest) */
#define GL_SRC_ALPHA                                                0x0302 /**< @brief OpenGL 1.0 enum (blending factor dest) */
#define GL_ONE_MINUS_SRC_ALPHA                                      0x0303 /**< @brief OpenGL 1.0 enum (blending factor dest) */
#define GL_DST_ALPHA                                                0x0304 /**< @brief OpenGL 1.0 enum (blending factor dest) */
#define GL_ONE_MINUS_DST_ALPHA                                      0x0305 /**< @brief OpenGL 1.0 enum (blending factor dest) */
/* BlendingFactorSrc */
#define GL_DST_COLOR                                                0x0306 /**< @brief OpenGL 1.0 enum (blending factor src) */
#define GL_ONE_MINUS_DST_COLOR                                      0x0307 /**< @brief OpenGL 1.0 enum (blending factor src) */
#define GL_SRC_ALPHA_SATURATE                                       0x0308 /**< @brief OpenGL 1.0 enum (blending factor src) */
/* DrawBufferMode */
#define GL_NONE                                                     0 /**< @brief OpenGL 1.0 enum (draw buffer mode) */
#define GL_FRONT_LEFT                                               0x0400 /**< @brief OpenGL 1.0 enum (draw buffer mode) */
#define GL_FRONT_RIGHT                                              0x0401 /**< @brief OpenGL 1.0 enum (draw buffer mode) */
#define GL_BACK_LEFT                                                0x0402 /**< @brief OpenGL 1.0 enum (draw buffer mode) */
#define GL_BACK_RIGHT                                               0x0403 /**< @brief OpenGL 1.0 enum (draw buffer mode) */
#define GL_FRONT                                                    0x0404 /**< @brief OpenGL 1.0 enum (draw buffer mode) */
#define GL_BACK                                                     0x0405 /**< @brief OpenGL 1.0 enum (draw buffer mode) */
#define GL_LEFT                                                     0x0406 /**< @brief OpenGL 1.0 enum (draw buffer mode) */
#define GL_RIGHT                                                    0x0407 /**< @brief OpenGL 1.0 enum (draw buffer mode) */
#define GL_FRONT_AND_BACK                                           0x0408 /**< @brief OpenGL 1.0 enum (draw buffer mode) */
/* ErrorCode */
#define GL_NO_ERROR                                                 0 /**< @brief OpenGL 1.0 enum (error code) */
#define GL_INVALID_ENUM                                             0x0500 /**< @brief OpenGL 1.0 enum (error code) */
#define GL_INVALID_VALUE                                            0x0501 /**< @brief OpenGL 1.0 enum (error code) */
#define GL_INVALID_OPERATION                                        0x0502 /**< @brief OpenGL 1.0 enum (error code) */
#define GL_OUT_OF_MEMORY                                            0x0505 /**< @brief OpenGL 1.0 enum (error code) */
/* FrontFaceDirection */
#define GL_CW                                                       0x0900 /**< @brief OpenGL 1.0 enum (front face direction) */
#define GL_CCW                                                      0x0901 /**< @brief OpenGL 1.0 enum (front face direction) */
/* GetPName */
#define GL_POINT_SIZE                                               0x0B11 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_POINT_SIZE_RANGE                                         0x0B12 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_POINT_SIZE_GRANULARITY                                   0x0B13 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_LINE_SMOOTH                                              0x0B20 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_LINE_WIDTH                                               0x0B21 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_LINE_WIDTH_RANGE                                         0x0B22 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_LINE_WIDTH_GRANULARITY                                   0x0B23 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_POLYGON_SMOOTH                                           0x0B41 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_CULL_FACE                                                0x0B44 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_CULL_FACE_MODE                                           0x0B45 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_FRONT_FACE                                               0x0B46 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_DEPTH_RANGE                                              0x0B70 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_DEPTH_TEST                                               0x0B71 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_DEPTH_WRITEMASK                                          0x0B72 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_DEPTH_CLEAR_VALUE                                        0x0B73 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_DEPTH_FUNC                                               0x0B74 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_STENCIL_TEST                                             0x0B90 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_STENCIL_CLEAR_VALUE                                      0x0B91 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_STENCIL_FUNC                                             0x0B92 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_STENCIL_VALUE_MASK                                       0x0B93 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_STENCIL_FAIL                                             0x0B94 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_STENCIL_PASS_DEPTH_FAIL                                  0x0B95 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_STENCIL_PASS_DEPTH_PASS                                  0x0B96 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_STENCIL_REF                                              0x0B97 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_STENCIL_WRITEMASK                                        0x0B98 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_VIEWPORT                                                 0x0BA2 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_DITHER                                                   0x0BD0 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_BLEND_DST                                                0x0BE0 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_BLEND_SRC                                                0x0BE1 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_BLEND                                                    0x0BE2 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_LOGIC_OP_MODE                                            0x0BF0 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_COLOR_LOGIC_OP                                           0x0BF2 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_DRAW_BUFFER                                              0x0C01 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_READ_BUFFER                                              0x0C02 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_SCISSOR_BOX                                              0x0C10 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_SCISSOR_TEST                                             0x0C11 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_COLOR_CLEAR_VALUE                                        0x0C22 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_COLOR_WRITEMASK                                          0x0C23 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_DOUBLEBUFFER                                             0x0C32 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_STEREO                                                   0x0C33 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_LINE_SMOOTH_HINT                                         0x0C52 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_POLYGON_SMOOTH_HINT                                      0x0C53 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_UNPACK_SWAP_BYTES                                        0x0CF0 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_UNPACK_LSB_FIRST                                         0x0CF1 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_UNPACK_ROW_LENGTH                                        0x0CF2 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_UNPACK_SKIP_ROWS                                         0x0CF3 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_UNPACK_SKIP_PIXELS                                       0x0CF4 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_UNPACK_ALIGNMENT                                         0x0CF5 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_PACK_SWAP_BYTES                                          0x0D00 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_PACK_LSB_FIRST                                           0x0D01 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_PACK_ROW_LENGTH                                          0x0D02 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_PACK_SKIP_ROWS                                           0x0D03 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_PACK_SKIP_PIXELS                                         0x0D04 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_PACK_ALIGNMENT                                           0x0D05 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_MAX_TEXTURE_SIZE                                         0x0D33 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_MAX_VIEWPORT_DIMS                                        0x0D3A /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_SUBPIXEL_BITS                                            0x0D50 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_TEXTURE_1D                                               0x0DE0 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_TEXTURE_2D                                               0x0DE1 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_POLYGON_OFFSET_UNITS                                     0x2A00 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_POLYGON_OFFSET_POINT                                     0x2A01 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_POLYGON_OFFSET_LINE                                      0x2A02 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_POLYGON_OFFSET_FILL                                      0x8037 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_POLYGON_OFFSET_FACTOR                                    0x8038 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_TEXTURE_BINDING_1D                                       0x8068 /**< @brief OpenGL 1.0 enum (get p name) */
#define GL_TEXTURE_BINDING_2D                                       0x8069 /**< @brief OpenGL 1.0 enum (get p name) */
/* GetTextureParameter */
#define GL_TEXTURE_WIDTH                                            0x1000 /**< @brief OpenGL 1.0 enum (get texture parameter) */
#define GL_TEXTURE_HEIGHT                                           0x1001 /**< @brief OpenGL 1.0 enum (get texture parameter) */
#define GL_TEXTURE_INTERNAL_FORMAT                                  0x1003 /**< @brief OpenGL 1.0 enum (get texture parameter) */
#define GL_TEXTURE_BORDER_COLOR                                     0x1004 /**< @brief OpenGL 1.0 enum (get texture parameter) */
#define GL_TEXTURE_BORDER                                           0x1005 /**< @brief OpenGL 1.0 enum (get texture parameter) */
#define GL_TEXTURE_RED_SIZE                                         0x805C /**< @brief OpenGL 1.0 enum (get texture parameter) */
#define GL_TEXTURE_GREEN_SIZE                                       0x805D /**< @brief OpenGL 1.0 enum (get texture parameter) */
#define GL_TEXTURE_BLUE_SIZE                                        0x805E /**< @brief OpenGL 1.0 enum (get texture parameter) */
#define GL_TEXTURE_ALPHA_SIZE                                       0x805F /**< @brief OpenGL 1.0 enum (get texture parameter) */
/* HintMode */
#define GL_DONT_CARE                                                0x1100 /**< @brief OpenGL 1.0 enum (hint mode) */
#define GL_FASTEST                                                  0x1101 /**< @brief OpenGL 1.0 enum (hint mode) */
#define GL_NICEST                                                   0x1102 /**< @brief OpenGL 1.0 enum (hint mode) */
/* DataType */
#define GL_BYTE                                                     0x1400 /**< @brief OpenGL 1.0 enum (data type) */
#define GL_UNSIGNED_BYTE                                            0x1401 /**< @brief OpenGL 1.0 enum (data type) */
#define GL_SHORT                                                    0x1402 /**< @brief OpenGL 1.0 enum (data type) */
#define GL_UNSIGNED_SHORT                                           0x1403 /**< @brief OpenGL 1.0 enum (data type) */
#define GL_INT                                                      0x1404 /**< @brief OpenGL 1.0 enum (data type) */
#define GL_UNSIGNED_INT                                             0x1405 /**< @brief OpenGL 1.0 enum (data type) */
#define GL_FLOAT                                                    0x1406 /**< @brief OpenGL 1.0 enum (data type) */
#define GL_DOUBLE                                                   0x140A /**< @brief OpenGL 1.0 enum (data type) */
/* LogicOp */
#define GL_CLEAR                                                    0x1500 /**< @brief OpenGL 1.0 enum (logic op) */
#define GL_AND                                                      0x1501 /**< @brief OpenGL 1.0 enum (logic op) */
#define GL_AND_REVERSE                                              0x1502 /**< @brief OpenGL 1.0 enum (logic op) */
#define GL_COPY                                                     0x1503 /**< @brief OpenGL 1.0 enum (logic op) */
#define GL_AND_INVERTED                                             0x1504 /**< @brief OpenGL 1.0 enum (logic op) */
#define GL_NOOP                                                     0x1505 /**< @brief OpenGL 1.0 enum (logic op) */
#define GL_XOR                                                      0x1506 /**< @brief OpenGL 1.0 enum (logic op) */
#define GL_OR                                                       0x1507 /**< @brief OpenGL 1.0 enum (logic op) */
#define GL_NOR                                                      0x1508 /**< @brief OpenGL 1.0 enum (logic op) */
#define GL_EQUIV                                                    0x1509 /**< @brief OpenGL 1.0 enum (logic op) */
#define GL_INVERT                                                   0x150A /**< @brief OpenGL 1.0 enum (logic op) */
#define GL_OR_REVERSE                                               0x150B /**< @brief OpenGL 1.0 enum (logic op) */
#define GL_COPY_INVERTED                                            0x150C /**< @brief OpenGL 1.0 enum (logic op) */
#define GL_OR_INVERTED                                              0x150D /**< @brief OpenGL 1.0 enum (logic op) */
#define GL_NAND                                                     0x150E /**< @brief OpenGL 1.0 enum (logic op) */
#define GL_SET                                                      0x150F /**< @brief OpenGL 1.0 enum (logic op) */
/* MatrixMode (for gl3.h, FBO attachment type) */
#define GL_TEXTURE                                                  0x1702 /**< @brief OpenGL 1.0 enum (matrix mode) */
/* PixelCopyType */
#define GL_COLOR                                                    0x1800 /**< @brief OpenGL 1.0 enum (pixel copy type) */
#define GL_DEPTH                                                    0x1801 /**< @brief OpenGL 1.0 enum (pixel copy type) */
#define GL_STENCIL                                                  0x1802 /**< @brief OpenGL 1.0 enum (pixel copy type) */
/* PixelFormat */
#define GL_STENCIL_INDEX                                            0x1901 /**< @brief OpenGL 1.0 enum (pixel format) */
#define GL_DEPTH_COMPONENT                                          0x1902 /**< @brief OpenGL 1.0 enum (pixel format) */
#define GL_RED                                                      0x1903 /**< @brief OpenGL 1.0 enum (pixel format) */
#define GL_GREEN                                                    0x1904 /**< @brief OpenGL 1.0 enum (pixel format) */
#define GL_BLUE                                                     0x1905 /**< @brief OpenGL 1.0 enum (pixel format) */
#define GL_ALPHA                                                    0x1906 /**< @brief OpenGL 1.0 enum (pixel format) */
#define GL_RGB                                                      0x1907 /**< @brief OpenGL 1.0 enum (pixel format) */
#define GL_RGBA                                                     0x1908 /**< @brief OpenGL 1.0 enum (pixel format) */
/* PolygonMode */
#define GL_POINT                                                    0x1B00 /**< @brief OpenGL 1.0 enum (polygon mode) */
#define GL_LINE                                                     0x1B01 /**< @brief OpenGL 1.0 enum (polygon mode) */
#define GL_FILL                                                     0x1B02 /**< @brief OpenGL 1.0 enum (polygon mode) */
/* StencilOp */
#define GL_KEEP                                                     0x1E00 /**< @brief OpenGL 1.0 enum (stencil op) */
#define GL_REPLACE                                                  0x1E01 /**< @brief OpenGL 1.0 enum (stencil op) */
#define GL_INCR                                                     0x1E02 /**< @brief OpenGL 1.0 enum (stencil op) */
#define GL_DECR                                                     0x1E03 /**< @brief OpenGL 1.0 enum (stencil op) */
/* StringName */
#define GL_VENDOR                                                   0x1F00 /**< @brief OpenGL 1.0 enum (string name) */
#define GL_RENDERER                                                 0x1F01 /**< @brief OpenGL 1.0 enum (string name) */
#define GL_VERSION                                                  0x1F02 /**< @brief OpenGL 1.0 enum (string name) */
#define GL_EXTENSIONS                                               0x1F03 /**< @brief OpenGL 1.0 enum (string name) */
/* TextureMagFilter */
#define GL_NEAREST                                                  0x2600 /**< @brief OpenGL 1.0 enum (texture mag filter) */
#define GL_LINEAR                                                   0x2601 /**< @brief OpenGL 1.0 enum (texture mag filter) */
/* TextureMinFilter */
#define GL_NEAREST_MIPMAP_NEAREST                                   0x2700 /**< @brief OpenGL 1.0 enum (texture min filter) */
#define GL_LINEAR_MIPMAP_NEAREST                                    0x2701 /**< @brief OpenGL 1.0 enum (texture min filter) */
#define GL_NEAREST_MIPMAP_LINEAR                                    0x2702 /**< @brief OpenGL 1.0 enum (texture min filter) */
#define GL_LINEAR_MIPMAP_LINEAR                                     0x2703 /**< @brief OpenGL 1.0 enum (texture min filter) */
/* TextureParameterName */
#define GL_TEXTURE_MAG_FILTER                                       0x2800 /**< @brief OpenGL 1.0 enum (texture parameter name) */
#define GL_TEXTURE_MIN_FILTER                                       0x2801 /**< @brief OpenGL 1.0 enum (texture parameter name) */
#define GL_TEXTURE_WRAP_S                                           0x2802 /**< @brief OpenGL 1.0 enum (texture parameter name) */
#define GL_TEXTURE_WRAP_T                                           0x2803 /**< @brief OpenGL 1.0 enum (texture parameter name) */
/* TextureTarget */
#define GL_PROXY_TEXTURE_1D                                         0x8063 /**< @brief OpenGL 1.0 enum (texture target) */
#define GL_PROXY_TEXTURE_2D                                         0x8064 /**< @brief OpenGL 1.0 enum (texture target) */
/* TextureWrapMode */
#define GL_REPEAT                                                   0x2901 /**< @brief OpenGL 1.0 enum (texture wrap mode) */
/* PixelInternalFormat */
#define GL_R3_G3_B2                                                 0x2A10 /**< @brief OpenGL 1.0 enum (pixel internal format) */
#define GL_RGB4                                                     0x804F /**< @brief OpenGL 1.0 enum (pixel internal format) */
#define GL_RGB5                                                     0x8050 /**< @brief OpenGL 1.0 enum (pixel internal format) */
#define GL_RGB8                                                     0x8051 /**< @brief OpenGL 1.0 enum (pixel internal format) */
#define GL_RGB10                                                    0x8052 /**< @brief OpenGL 1.0 enum (pixel internal format) */
#define GL_RGB12                                                    0x8053 /**< @brief OpenGL 1.0 enum (pixel internal format) */
#define GL_RGB16                                                    0x8054 /**< @brief OpenGL 1.0 enum (pixel internal format) */
#define GL_RGBA2                                                    0x8055 /**< @brief OpenGL 1.0 enum (pixel internal format) */
#define GL_RGBA4                                                    0x8056 /**< @brief OpenGL 1.0 enum (pixel internal format) */
#define GL_RGB5_A1                                                  0x8057 /**< @brief OpenGL 1.0 enum (pixel internal format) */
#define GL_RGBA8                                                    0x8058 /**< @brief OpenGL 1.0 enum (pixel internal format) */
#define GL_RGB10_A2                                                 0x8059 /**< @brief OpenGL 1.0 enum (pixel internal format) */
#define GL_RGBA12                                                   0x805A /**< @brief OpenGL 1.0 enum (pixel internal format) */
#define GL_RGBA16                                                   0x805B /**< @brief OpenGL 1.0 enum (pixel internal format) */

#ifdef __cplusplus
extern "C" {
#endif

/**
 *  @brief specify whether front- or back-facing facets can be culled
 *  @param[in] mode Specifies whether front- or back-facing facets are candidates for culling.
 *      Symbolic constants GL_FRONT, GL_BACK, and GL_FRONT_AND_BACK are accepted. The initial value
 *      is GL_BACK.
 */
GLStaticApi void ApiEntry glCullFace(GLenum mode);

/**
 *  @brief define front- and back-facing polygons
 *  @param[in] mode Specifies the orientation of front-facing polygons. GL_CW and GL_CCW are
 *      accepted. The initial value is GL_CCW.
 */
GLStaticApi void ApiEntry glFrontFace(GLenum mode);

/**
 *  @brief specify implementation-specific hints
 *  @param[in] target Specifies a symbolic constant indicating the behavior to be controlled.
 *      GL_LINE_SMOOTH_HINT, GL_POLYGON_SMOOTH_HINT, GL_TEXTURE_COMPRESSION_HINT, and
 *      GL_FRAGMENT_SHADER_DERIVATIVE_HINT are accepted.
 *  @param[in] mode Specifies a symbolic constant indicating the desired behavior. GL_FASTEST,
 *      GL_NICEST, and GL_DONT_CARE are accepted.
 */
GLStaticApi void ApiEntry glHint(GLenum target, GLenum mode);

/**
 *  @brief specify the width of rasterized lines
 *  @param[in] width Specifies the width of rasterized lines. The initial value is 1.
 */
GLStaticApi void ApiEntry glLineWidth(float width);

/**
 *  @brief specify the diameter of rasterized points
 *  @param[in] size Specifies the diameter of rasterized points. The initial value is 1.
 */
GLStaticApi void ApiEntry glPointSize(float size);

/**
 *  @brief select a polygon rasterization mode
 *  @param[in] face Specifies the polygons that mode applies to. Must be GL_FRONT_AND_BACK for
 *      front- and back-facing polygons.
 *  @param[in] mode Specifies how polygons will be rasterized. Accepted values are GL_POINT,
 *      GL_LINE, and GL_FILL. The initial value is GL_FILL for both front- and back-facing polygons.
 */
GLStaticApi void ApiEntry glPolygonMode(GLenum face, GLenum mode);

/**
 *  @brief define the scissor box
 *  @param[in] x Specify the lower left corner of the scissor box. Initially (0, 0).
 *  @param[in] y Specify the lower left corner of the scissor box. Initially (0, 0).
 *  @param[in] width Specify the width and height of the scissor box. When a GL context is first
 *      attached to a window, width and height are set to the dimensions of that window.
 *  @param[in] height Specify the width and height of the scissor box. When a GL context is first
 *      attached to a window, width and height are set to the dimensions of that window.
 */
GLStaticApi void ApiEntry glScissor(int x, int y, GLsizei width, GLsizei height);

/**
 *  @brief set texture parameters
 *  @param[in] target Specifies the target texture, which must be either GL_TEXTURE_1D,
 *      GL_TEXTURE_2D, GL_TEXTURE_3D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY,
 *      GL_TEXTURE_RECTANGLE, or GL_TEXTURE_CUBE_MAP.
 *  @param[in] pname Specifies the symbolic name of a single-valued texture parameter. pname can be
 *      one of the following: GL_TEXTURE_BASE_LEVEL, GL_TEXTURE_COMPARE_FUNC,
 *      GL_TEXTURE_COMPARE_MODE, GL_TEXTURE_LOD_BIAS, GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MAG_FILTER,
 *      GL_TEXTURE_MIN_LOD, GL_TEXTURE_MAX_LOD, GL_TEXTURE_MAX_LEVEL, GL_TEXTURE_SWIZZLE_R,
 *      GL_TEXTURE_SWIZZLE_G, GL_TEXTURE_SWIZZLE_B, GL_TEXTURE_SWIZZLE_A, GL_TEXTURE_WRAP_S,
 *      GL_TEXTURE_WRAP_T, or GL_TEXTURE_WRAP_R.
 *  @param[in] param Specifies the value of pname.
 */
GLStaticApi void ApiEntry glTexParameterf(GLenum target, GLenum pname, float param);

/**
 *  @brief set texture parameters
 *  @param[in] target Specifies the target texture, which must be either GL_TEXTURE_1D,
 *      GL_TEXTURE_2D, GL_TEXTURE_3D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY,
 *      GL_TEXTURE_RECTANGLE, or GL_TEXTURE_CUBE_MAP.
 *  @param[in] pname Specifies the symbolic name of a texture parameter. pname can be one of the
 *      following: GL_TEXTURE_BASE_LEVEL, GL_TEXTURE_BORDER_COLOR, GL_TEXTURE_COMPARE_FUNC,
 *      GL_TEXTURE_COMPARE_MODE, GL_TEXTURE_LOD_BIAS, GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MAG_FILTER,
 *      GL_TEXTURE_MIN_LOD, GL_TEXTURE_MAX_LOD, GL_TEXTURE_MAX_LEVEL, GL_TEXTURE_SWIZZLE_R,
 *      GL_TEXTURE_SWIZZLE_G, GL_TEXTURE_SWIZZLE_B, GL_TEXTURE_SWIZZLE_A, GL_TEXTURE_SWIZZLE_RGBA,
 *      GL_TEXTURE_WRAP_S, GL_TEXTURE_WRAP_T, or GL_TEXTURE_WRAP_R.
 *  @param[in] params Specifies a pointer to an array where the value or values of pname are stored.
 */
GLStaticApi void ApiEntry glTexParameterfv(GLenum target, GLenum pname, const float *params);

/**
 *  @brief set texture parameters
 *  @param[in] target Specifies the target texture, which must be either GL_TEXTURE_1D,
 *      GL_TEXTURE_2D, GL_TEXTURE_3D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY,
 *      GL_TEXTURE_RECTANGLE, or GL_TEXTURE_CUBE_MAP.
 *  @param[in] pname Specifies the symbolic name of a single-valued texture parameter. pname can be
 *      one of the following: GL_TEXTURE_BASE_LEVEL, GL_TEXTURE_COMPARE_FUNC,
 *      GL_TEXTURE_COMPARE_MODE, GL_TEXTURE_LOD_BIAS, GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MAG_FILTER,
 *      GL_TEXTURE_MIN_LOD, GL_TEXTURE_MAX_LOD, GL_TEXTURE_MAX_LEVEL, GL_TEXTURE_SWIZZLE_R,
 *      GL_TEXTURE_SWIZZLE_G, GL_TEXTURE_SWIZZLE_B, GL_TEXTURE_SWIZZLE_A, GL_TEXTURE_WRAP_S,
 *      GL_TEXTURE_WRAP_T, or GL_TEXTURE_WRAP_R.
 *  @param[in] param Specifies the value of pname.
 */
GLStaticApi void ApiEntry glTexParameteri(GLenum target, GLenum pname, int param);

/**
 *  @brief set texture parameters
 *  @param[in] target Specifies the target texture, which must be either GL_TEXTURE_1D,
 *      GL_TEXTURE_2D, GL_TEXTURE_3D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY,
 *      GL_TEXTURE_RECTANGLE, or GL_TEXTURE_CUBE_MAP.
 *  @param[in] pname Specifies the symbolic name of a texture parameter. pname can be one of the
 *      following: GL_TEXTURE_BASE_LEVEL, GL_TEXTURE_BORDER_COLOR, GL_TEXTURE_COMPARE_FUNC,
 *      GL_TEXTURE_COMPARE_MODE, GL_TEXTURE_LOD_BIAS, GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MAG_FILTER,
 *      GL_TEXTURE_MIN_LOD, GL_TEXTURE_MAX_LOD, GL_TEXTURE_MAX_LEVEL, GL_TEXTURE_SWIZZLE_R,
 *      GL_TEXTURE_SWIZZLE_G, GL_TEXTURE_SWIZZLE_B, GL_TEXTURE_SWIZZLE_A, GL_TEXTURE_SWIZZLE_RGBA,
 *      GL_TEXTURE_WRAP_S, GL_TEXTURE_WRAP_T, or GL_TEXTURE_WRAP_R.
 *  @param[in] params Specifies a pointer to an array where the value or values of pname are stored.
 */
GLStaticApi void ApiEntry glTexParameteriv(GLenum target, GLenum pname, const int *params);

/**
 *  @brief specify a one-dimensional texture image
 *  @param[in] target Specifies the target texture. Must be GL_TEXTURE_1D or GL_PROXY_TEXTURE_1D.
 *  @param[in] level Specifies the level-of-detail number. Level 0 is the base image level. Level n
 *      is the nth mipmap reduction image.
 *  @param[in] internalFormat Specifies the number of color components in the texture. Must be one
 *      of the following symbolic constants: GL_COMPRESSED_RED, GL_COMPRESSED_RG, GL_COMPRESSED_RGB,
 *      GL_COMPRESSED_RGBA, GL_COMPRESSED_SRGB, GL_COMPRESSED_SRGB_ALPHA, GL_DEPTH_COMPONENT,
 *      GL_DEPTH_COMPONENT16, GL_DEPTH_COMPONENT24, GL_DEPTH_COMPONENT32, GL_R3_G3_B2, GL_RED,
 *      GL_RG, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2,
 *      GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, GL_RGBA16, GL_SRGB, GL_SRGB8,
 *      GL_SRGB_ALPHA, or GL_SRGB8_ALPHA8.
 *  @param[in] width Specifies the width of the texture image. All implementations support texture
 *      images that are at least 1024 texels wide. The height of the 1D texture image is 1.
 *  @param[in] border This value must be 0.
 *  @param[in] format Specifies the format of the pixel data. The following symbolic values are
 *      accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, and GL_BGRA.
 *  @param[in] type Specifies the data type of the pixel data. The following symbolic values are
 *      accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT,
 *      GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5,
 *      GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV,
 *      GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8,
 *      GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
 *  @param[in] data Specifies a pointer to the image data in memory.
 */
GLStaticApi void ApiEntry glTexImage1D(GLenum target, int level, int internalFormat, GLsizei width, int border, GLenum format, GLenum type, const void *data);

/**
 *  @brief specify a two-dimensional texture image
 *  @param[in] target Specifies the target texture. Must be GL_TEXTURE_2D, GL_PROXY_TEXTURE_2D,
 *      GL_TEXTURE_1D_ARRAY, GL_PROXY_TEXTURE_1D_ARRAY, GL_TEXTURE_RECTANGLE,
 *      GL_PROXY_TEXTURE_RECTANGLE, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X,
 *      GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y,
 *      GL_TEXTURE_CUBE_MAP_POSITIVE_Z, GL_TEXTURE_CUBE_MAP_NEGATIVE_Z, or GL_PROXY_TEXTURE_CUBE_MAP.
 *  @param[in] level Specifies the level-of-detail number. Level 0 is the base image level. Level n
 *      is the nth mipmap reduction image. If target is GL_TEXTURE_RECTANGLE or
 *      GL_PROXY_TEXTURE_RECTANGLE, level must be 0.
 *  @param[in] internalFormat Specifies the number of color components in the texture. Must be one
 *      of the following symbolic constants: GL_COMPRESSED_RED, GL_COMPRESSED_RG, GL_COMPRESSED_RGB,
 *      GL_COMPRESSED_RGBA, GL_COMPRESSED_SRGB, GL_COMPRESSED_SRGB_ALPHA, GL_DEPTH_COMPONENT,
 *      GL_DEPTH_COMPONENT16, GL_DEPTH_COMPONENT24, GL_DEPTH_COMPONENT32, GL_R3_G3_B2, GL_RED,
 *      GL_RG, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2,
 *      GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, GL_RGBA16, GL_SRGB, GL_SRGB8,
 *      GL_SRGB_ALPHA, or GL_SRGB8_ALPHA8.
 *  @param[in] width Specifies the width of the texture image. All implementations support texture
 *      images that are at least 1024 texels wide.
 *  @param[in] height Specifies the height of the texture image, or the number of layers in a
 *      texture array, in the case of the GL_TEXTURE_1D_ARRAY and GL_PROXY_TEXTURE_1D_ARRAY targets.
 *      All implementations support 2D texture images that are at least 1024 texels high, and
 *      texture arrays that are at least 256 layers deep.
 *  @param[in] border This value must be 0.
 *  @param[in] format Specifies the format of the pixel data. The following symbolic values are
 *      accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, and GL_BGRA.
 *  @param[in] type Specifies the data type of the pixel data. The following symbolic values are
 *      accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT,
 *      GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5,
 *      GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV,
 *      GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8,
 *      GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
 *  @param[in] data Specifies a pointer to the image data in memory.
 */
GLStaticApi void ApiEntry glTexImage2D(GLenum target, int level, int internalFormat, GLsizei width, GLsizei height, int border, GLenum format, GLenum type, const void *data);

/**
 *  @brief specify which color buffers are to be drawn into
 *  @param[in] mode Specifies up to four color buffers to be drawn into. Symbolic constants GL_NONE,
 *      GL_FRONT_LEFT, GL_FRONT_RIGHT, GL_BACK_LEFT, GL_BACK_RIGHT, GL_FRONT, GL_BACK, GL_LEFT,
 *      GL_RIGHT, and GL_FRONT_AND_BACK are accepted. The initial value is GL_FRONT for
 *      single-buffered contexts, and GL_BACK for double-buffered contexts.
 */
GLStaticApi void ApiEntry glDrawBuffer(GLenum mode);

/**
 *  @brief clear buffers to preset values
 *  @param[in] mask Bitwise OR of masks that indicate the buffers to be cleared. The three masks are
 *      GL_COLOR_BUFFER_BIT, GL_DEPTH_BUFFER_BIT, and GL_STENCIL_BUFFER_BIT.
 */
GLStaticApi void ApiEntry glClear(GLbitfield mask);

/**
 *  @brief specify clear values for the color buffers
 *  @param[in] red Specify the red, green, blue, and alpha values used when the color buffers are
 *      cleared. The initial values are all 0.
 *  @param[in] green Specify the red, green, blue, and alpha values used when the color buffers are
 *      cleared. The initial values are all 0.
 *  @param[in] blue Specify the red, green, blue, and alpha values used when the color buffers are
 *      cleared. The initial values are all 0.
 *  @param[in] alpha Specify the red, green, blue, and alpha values used when the color buffers are
 *      cleared. The initial values are all 0.
 */
GLStaticApi void ApiEntry glClearColor(GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha);

/**
 *  @brief specify the clear value for the stencil buffer
 *  @param[in] s Specifies the index used when the stencil buffer is cleared. The initial value is 0.
 */
GLStaticApi void ApiEntry glClearStencil(int s);

/**
 *  @brief specify the clear value for the depth buffer
 *  @param[in] depth Specifies the depth value used when the depth buffer is cleared. The initial
 *      value is 1.
 */
GLStaticApi void ApiEntry glClearDepth(GLclampd depth);

/**
 *  @brief control the front and back writing of individual bits in the stencil planes
 *  @param[in] mask Specifies a bit mask to enable and disable writing of individual bits in the
 *      stencil planes. Initially, the mask is all 1's.
 */
GLStaticApi void ApiEntry glStencilMask(GLuint mask);

/**
 *  @brief enable and disable writing of frame buffer color components
 *  @param[in] red Specify whether red, green, blue, and alpha are to be written into the frame
 *      buffer. The initial values are all GL_TRUE, indicating that the color components are written.
 *  @param[in] green Specify whether red, green, blue, and alpha are to be written into the frame
 *      buffer. The initial values are all GL_TRUE, indicating that the color components are written.
 *  @param[in] blue Specify whether red, green, blue, and alpha are to be written into the frame
 *      buffer. The initial values are all GL_TRUE, indicating that the color components are written.
 *  @param[in] alpha Specify whether red, green, blue, and alpha are to be written into the frame
 *      buffer. The initial values are all GL_TRUE, indicating that the color components are written.
 */
GLStaticApi void ApiEntry glColorMask(GLboolean red, GLboolean green, GLboolean blue, GLboolean alpha);

/**
 *  @brief enable or disable writing into the depth buffer
 *  @param[in] flag Specifies whether the depth buffer is enabled for writing. If flag is GL_FALSE,
 *      depth buffer writing is disabled. Otherwise, it is enabled. Initially, depth buffer writing
 *      is enabled.
 */
GLStaticApi void ApiEntry glDepthMask(GLboolean flag);

/**
 *  @brief enable or disable server-side GL capabilities
 *  @param[in] cap Specifies a symbolic constant indicating a GL capability.
 */
GLStaticApi void ApiEntry glDisable(GLenum cap);

/**
 *  @brief enable or disable server-side GL capabilities
 *  @param[in] cap Specifies a symbolic constant indicating a GL capability.
 */
GLStaticApi void ApiEntry glEnable(GLenum cap);

/**
 *  @brief block until all GL execution is complete
 */
GLStaticApi void ApiEntry glFinish();

/**
 *  @brief force execution of GL commands in finite time
 */
GLStaticApi void ApiEntry glFlush();

/**
 *  @brief specify pixel arithmetic
 *  @param[in] sfactor Specifies how the red, green, blue, and alpha source blending factors are
 *      computed. The initial value is GL_ONE.
 *  @param[in] dfactor Specifies how the red, green, blue, and alpha destination blending factors
 *      are computed. The following symbolic constants are accepted: GL_ZERO, GL_ONE, GL_SRC_COLOR,
 *      GL_ONE_MINUS_SRC_COLOR, GL_DST_COLOR, GL_ONE_MINUS_DST_COLOR, GL_SRC_ALPHA,
 *      GL_ONE_MINUS_SRC_ALPHA, GL_DST_ALPHA, GL_ONE_MINUS_DST_ALPHA. GL_CONSTANT_COLOR,
 *      GL_ONE_MINUS_CONSTANT_COLOR, GL_CONSTANT_ALPHA, and GL_ONE_MINUS_CONSTANT_ALPHA. The initial
 *      value is GL_ZERO.
 */
GLStaticApi void ApiEntry glBlendFunc(GLenum sfactor, GLenum dfactor);

/**
 *  @brief specify a logical pixel operation for rendering
 *  @param[in] opcode Specifies a symbolic constant that selects a logical operation. The following
 *      symbols are accepted: GL_CLEAR, GL_SET, GL_COPY, GL_COPY_INVERTED, GL_NOOP, GL_INVERT,
 *      GL_AND, GL_NAND, GL_OR, GL_NOR, GL_XOR, GL_EQUIV, GL_AND_REVERSE, GL_AND_INVERTED,
 *      GL_OR_REVERSE, and GL_OR_INVERTED. The initial value is GL_COPY.
 */
GLStaticApi void ApiEntry glLogicOp(GLenum opcode);

/**
 *  @brief set front and back function and reference value for stencil testing
 *  @param[in] func Specifies the test function. Eight symbolic constants are valid: GL_NEVER,
 *      GL_LESS, GL_LEQUAL, GL_GREATER, GL_GEQUAL, GL_EQUAL, GL_NOTEQUAL, and GL_ALWAYS. The initial
 *      value is GL_ALWAYS.
 *  @param[in] ref Specifies the reference value for the stencil test. ref is clamped to the range 0
 *      2 n - 1, where n is the number of bitplanes in the stencil buffer. The initial value is 0.
 *  @param[in] mask Specifies a mask that is ANDed with both the reference value and the stored
 *      stencil value when the test is done. The initial value is all 1's.
 */
GLStaticApi void ApiEntry glStencilFunc(GLenum func, int ref, GLuint mask);

/**
 *  @brief set front and back stencil test actions
 *  @param[in] sfail Specifies the action to take when the stencil test fails. Eight symbolic
 *      constants are accepted: GL_KEEP, GL_ZERO, GL_REPLACE, GL_INCR, GL_INCR_WRAP, GL_DECR,
 *      GL_DECR_WRAP, and GL_INVERT. The initial value is GL_KEEP.
 *  @param[in] dpfail Specifies the stencil action when the stencil test passes, but the depth test
 *      fails. dpfail accepts the same symbolic constants as sfail. The initial value is GL_KEEP.
 *  @param[in] dppass Specifies the stencil action when both the stencil test and the depth test
 *      pass, or when the stencil test passes and either there is no depth buffer or depth testing
 *      is not enabled. dppass accepts the same symbolic constants as sfail. The initial value is GL_KEEP.
 */
GLStaticApi void ApiEntry glStencilOp(GLenum sfail, GLenum dpfail, GLenum dppass);

/**
 *  @brief specify the value used for depth buffer comparisons
 *  @param[in] func Specifies the depth comparison function. Symbolic constants GL_NEVER, GL_LESS,
 *      GL_EQUAL, GL_LEQUAL, GL_GREATER, GL_NOTEQUAL, GL_GEQUAL, and GL_ALWAYS are accepted. The
 *      initial value is GL_LESS.
 */
GLStaticApi void ApiEntry glDepthFunc(GLenum func);

/**
 *  @brief set pixel storage modes
 *  @param[in] pname Specifies the symbolic name of the parameter to be set. Six values affect the
 *      packing of pixel data into memory: GL_PACK_SWAP_BYTES, GL_PACK_LSB_FIRST,
 *      GL_PACK_ROW_LENGTH, GL_PACK_IMAGE_HEIGHT, GL_PACK_SKIP_PIXELS, GL_PACK_SKIP_ROWS,
 *      GL_PACK_SKIP_IMAGES, and GL_PACK_ALIGNMENT. Six more affect the unpacking of pixel data from
 *      memory: GL_UNPACK_SWAP_BYTES, GL_UNPACK_LSB_FIRST, GL_UNPACK_ROW_LENGTH,
 *      GL_UNPACK_IMAGE_HEIGHT, GL_UNPACK_SKIP_PIXELS, GL_UNPACK_SKIP_ROWS, GL_UNPACK_SKIP_IMAGES,
 *      and GL_UNPACK_ALIGNMENT.
 *  @param[in] param Specifies the value that pname is set to.
 */
GLStaticApi void ApiEntry glPixelStoref(GLenum pname, float param);

/**
 *  @brief set pixel storage modes
 *  @param[in] pname Specifies the symbolic name of the parameter to be set. Six values affect the
 *      packing of pixel data into memory: GL_PACK_SWAP_BYTES, GL_PACK_LSB_FIRST,
 *      GL_PACK_ROW_LENGTH, GL_PACK_IMAGE_HEIGHT, GL_PACK_SKIP_PIXELS, GL_PACK_SKIP_ROWS,
 *      GL_PACK_SKIP_IMAGES, and GL_PACK_ALIGNMENT. Six more affect the unpacking of pixel data from
 *      memory: GL_UNPACK_SWAP_BYTES, GL_UNPACK_LSB_FIRST, GL_UNPACK_ROW_LENGTH,
 *      GL_UNPACK_IMAGE_HEIGHT, GL_UNPACK_SKIP_PIXELS, GL_UNPACK_SKIP_ROWS, GL_UNPACK_SKIP_IMAGES,
 *      and GL_UNPACK_ALIGNMENT.
 *  @param[in] param Specifies the value that pname is set to.
 */
GLStaticApi void ApiEntry glPixelStorei(GLenum pname, int param);

/**
 *  @brief select a color buffer source for pixels
 *  @param[in] mode Specifies a color buffer. Accepted values are GL_FRONT_LEFT, GL_FRONT_RIGHT,
 *      GL_BACK_LEFT, GL_BACK_RIGHT, GL_FRONT, GL_BACK, GL_LEFT, and GL_RIGHT.
 */
GLStaticApi void ApiEntry glReadBuffer(GLenum mode);

/**
 *  @brief read a block of pixels from the frame buffer
 *  @param[in] x Specify the window coordinates of the first pixel that is read from the frame
 *      buffer. This location is the lower left corner of a rectangular block of pixels.
 *  @param[in] y Specify the window coordinates of the first pixel that is read from the frame
 *      buffer. This location is the lower left corner of a rectangular block of pixels.
 *  @param[in] width Specify the dimensions of the pixel rectangle. width and height of one
 *      correspond to a single pixel.
 *  @param[in] height Specify the dimensions of the pixel rectangle. width and height of one
 *      correspond to a single pixel.
 *  @param[in] format Specifies the format of the pixel data. The following symbolic values are
 *      accepted: GL_STENCIL_INDEX, GL_DEPTH_COMPONENT, GL_DEPTH_STENCIL, GL_RED, GL_GREEN, GL_BLUE,
 *      GL_RGB, GL_BGR, GL_RGBA, and GL_BGRA.
 *  @param[in] type Specifies the data type of the pixel data. Must be one of GL_UNSIGNED_BYTE,
 *      GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_HALF_FLOAT, GL_FLOAT,
 *      GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5,
 *      GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV,
 *      GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8,
 *      GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, GL_UNSIGNED_INT_2_10_10_10_REV,
 *      GL_UNSIGNED_INT_24_8, GL_UNSIGNED_INT_10F_11F_11F_REV, GL_UNSIGNED_INT_5_9_9_9_REV, or GL_FLOAT_32_UNSIGNED_INT_24_8_REV.
 *  @param[out] data Returns the pixel data.
 */
GLStaticApi void ApiEntry glReadPixels(int x, int y, GLsizei width, GLsizei height, GLenum format, GLenum type, void *data);

/**
 *  @brief return the value or values of a selected parameter
 *  @param[in] pname Specifies the parameter value to be returned. The symbolic constants in the
 *      list below are accepted.
 *  @param[out] params Returns the value or values of the specified parameter.
 */
GLStaticApi void ApiEntry glGetBooleanv(GLenum pname, GLboolean *params);

/**
 *  @brief return the value or values of a selected parameter
 *  @param[in] pname Specifies the parameter value to be returned. The symbolic constants in the
 *      list below are accepted.
 *  @param[out] params Returns the value or values of the specified parameter.
 */
GLStaticApi void ApiEntry glGetDoublev(GLenum pname, double *params);

/**
 *  @brief return error information
 */
GLStaticApi GLenum ApiEntry glGetError();

/**
 *  @brief return the value or values of a selected parameter
 *  @param[in] pname Specifies the parameter value to be returned. The symbolic constants in the
 *      list below are accepted.
 *  @param[out] params Returns the value or values of the specified parameter.
 */
GLStaticApi void ApiEntry glGetFloatv(GLenum pname, float *params);

/**
 *  @brief return the value or values of a selected parameter
 *  @param[in] pname Specifies the parameter value to be returned. The symbolic constants in the
 *      list below are accepted.
 *  @param[out] params Returns the value or values of the specified parameter.
 */
GLStaticApi void ApiEntry glGetIntegerv(GLenum pname, int *params);

/**
 *  @brief return a string describing the current GL connection
 *  @param[in] name Specifies a symbolic constant, one of GL_VENDOR, GL_RENDERER, GL_VERSION, or
 *      GL_SHADING_LANGUAGE_VERSION. Additionally, glGetStringi accepts the GL_EXTENSIONS token.
 */
GLStaticApi const GLubyte *ApiEntry glGetString(GLenum name);

/**
 *  @brief return a texture image
 *  @param[in] target Specifies which texture is to be obtained. GL_TEXTURE_1D, GL_TEXTURE_2D,
 *      GL_TEXTURE_3D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY, GL_TEXTURE_RECTANGLE,
 *      GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X,
 *      GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y,
 *      GL_TEXTURE_CUBE_MAP_POSITIVE_Z, and GL_TEXTURE_CUBE_MAP_NEGATIVE_Z are accepted.
 *  @param[in] level Specifies the level-of-detail number of the desired image. Level 0 is the base
 *      image level. Level n is the nth mipmap reduction image.
 *  @param[in] format Specifies a pixel format for the returned data. The supported formats are
 *      GL_STENCIL_INDEX, GL_DEPTH_COMPONENT, GL_DEPTH_STENCIL, GL_RED, GL_GREEN, GL_BLUE, GL_RG,
 *      GL_RGB, GL_RGBA, GL_BGR, GL_BGRA, GL_RED_INTEGER, GL_GREEN_INTEGER, GL_BLUE_INTEGER,
 *      GL_RG_INTEGER, GL_RGB_INTEGER, GL_RGBA_INTEGER, GL_BGR_INTEGER, GL_BGRA_INTEGER.
 *  @param[in] type Specifies a pixel type for the returned data. The supported types are
 *      GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT,
 *      GL_HALF_FLOAT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV,
 *      GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4,
 *      GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV,
 *      GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2,
 *      GL_UNSIGNED_INT_2_10_10_10_REV, GL_UNSIGNED_INT_24_8, GL_UNSIGNED_INT_10F_11F_11F_REV,
 *      GL_UNSIGNED_INT_5_9_9_9_REV, and GL_FLOAT_32_UNSIGNED_INT_24_8_REV.
 *  @param[out] img Returns the texture image. Should be a pointer to an array of the type specified
 *      by type.
 */
GLStaticApi void ApiEntry glGetTexImage(GLenum target, int level, GLenum format, GLenum type, void *img);

/**
 *  @brief return texture parameter values
 *  @param[in] target Specifies the symbolic name of the target texture. GL_TEXTURE_1D,
 *      GL_TEXTURE_2D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY, GL_TEXTURE_3D,
 *      GL_TEXTURE_RECTANGLE, and GL_TEXTURE_CUBE_MAP are accepted.
 *  @param[in] pname Specifies the symbolic name of a texture parameter. GL_TEXTURE_BASE_LEVEL,
 *      GL_TEXTURE_BORDER_COLOR, GL_TEXTURE_COMPARE_MODE, GL_TEXTURE_COMPARE_FUNC,
 *      GL_TEXTURE_LOD_BIAS, GL_TEXTURE_MAG_FILTER, GL_TEXTURE_MAX_LEVEL, GL_TEXTURE_MAX_LOD,
 *      GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MIN_LOD, GL_TEXTURE_SWIZZLE_R, GL_TEXTURE_SWIZZLE_G,
 *      GL_TEXTURE_SWIZZLE_B, GL_TEXTURE_SWIZZLE_A, GL_TEXTURE_SWIZZLE_RGBA, GL_TEXTURE_WRAP_S,
 *      GL_TEXTURE_WRAP_T, and GL_TEXTURE_WRAP_R are accepted.
 *  @param[out] params Returns the texture parameters.
 */
GLStaticApi void ApiEntry glGetTexParameterfv(GLenum target, GLenum pname, float *params);

/**
 *  @brief return texture parameter values
 *  @param[in] target Specifies the symbolic name of the target texture. GL_TEXTURE_1D,
 *      GL_TEXTURE_2D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY, GL_TEXTURE_3D,
 *      GL_TEXTURE_RECTANGLE, and GL_TEXTURE_CUBE_MAP are accepted.
 *  @param[in] pname Specifies the symbolic name of a texture parameter. GL_TEXTURE_BASE_LEVEL,
 *      GL_TEXTURE_BORDER_COLOR, GL_TEXTURE_COMPARE_MODE, GL_TEXTURE_COMPARE_FUNC,
 *      GL_TEXTURE_LOD_BIAS, GL_TEXTURE_MAG_FILTER, GL_TEXTURE_MAX_LEVEL, GL_TEXTURE_MAX_LOD,
 *      GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MIN_LOD, GL_TEXTURE_SWIZZLE_R, GL_TEXTURE_SWIZZLE_G,
 *      GL_TEXTURE_SWIZZLE_B, GL_TEXTURE_SWIZZLE_A, GL_TEXTURE_SWIZZLE_RGBA, GL_TEXTURE_WRAP_S,
 *      GL_TEXTURE_WRAP_T, and GL_TEXTURE_WRAP_R are accepted.
 *  @param[out] params Returns the texture parameters.
 */
GLStaticApi void ApiEntry glGetTexParameteriv(GLenum target, GLenum pname, int *params);

/**
 *  @brief return texture parameter values for a specific level of detail
 *  @param[in] target Specifies the symbolic name of the target texture, one of GL_TEXTURE_1D,
 *      GL_TEXTURE_2D, GL_TEXTURE_3D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY,
 *      GL_TEXTURE_RECTANGLE, GL_TEXTURE_2D_MULTISAMPLE, GL_TEXTURE_2D_MULTISAMPLE_ARRAY,
 *      GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X,
 *      GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y,
 *      GL_TEXTURE_CUBE_MAP_POSITIVE_Z, GL_TEXTURE_CUBE_MAP_NEGATIVE_Z, GL_PROXY_TEXTURE_1D,
 *      GL_PROXY_TEXTURE_2D, GL_PROXY_TEXTURE_3D, GL_PROXY_TEXTURE_1D_ARRAY,
 *      GL_PROXY_TEXTURE_2D_ARRAY, GL_PROXY_TEXTURE_RECTANGLE, GL_PROXY_TEXTURE_2D_MULTISAMPLE,
 *      GL_PROXY_TEXTURE_2D_MULTISAMPLE_ARRAY, GL_PROXY_TEXTURE_CUBE_MAP, or GL_TEXTURE_BUFFER.
 *  @param[in] level Specifies the level-of-detail number of the desired image. Level 0 is the base
 *      image level. Level n is the nth mipmap reduction image.
 *  @param[in] pname Specifies the symbolic name of a texture parameter. GL_TEXTURE_WIDTH,
 *      GL_TEXTURE_HEIGHT, GL_TEXTURE_DEPTH, GL_TEXTURE_INTERNAL_FORMAT, GL_TEXTURE_BORDER,
 *      GL_TEXTURE_RED_SIZE, GL_TEXTURE_GREEN_SIZE, GL_TEXTURE_BLUE_SIZE, GL_TEXTURE_ALPHA_SIZE,
 *      GL_TEXTURE_DEPTH_SIZE, GL_TEXTURE_COMPRESSED, and GL_TEXTURE_COMPRESSED_IMAGE_SIZE are accepted.
 *  @param[out] params Returns the requested data.
 */
GLStaticApi void ApiEntry glGetTexLevelParameterfv(GLenum target, int level, GLenum pname, float *params);

/**
 *  @brief return texture parameter values for a specific level of detail
 *  @param[in] target Specifies the symbolic name of the target texture, one of GL_TEXTURE_1D,
 *      GL_TEXTURE_2D, GL_TEXTURE_3D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY,
 *      GL_TEXTURE_RECTANGLE, GL_TEXTURE_2D_MULTISAMPLE, GL_TEXTURE_2D_MULTISAMPLE_ARRAY,
 *      GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X,
 *      GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y,
 *      GL_TEXTURE_CUBE_MAP_POSITIVE_Z, GL_TEXTURE_CUBE_MAP_NEGATIVE_Z, GL_PROXY_TEXTURE_1D,
 *      GL_PROXY_TEXTURE_2D, GL_PROXY_TEXTURE_3D, GL_PROXY_TEXTURE_1D_ARRAY,
 *      GL_PROXY_TEXTURE_2D_ARRAY, GL_PROXY_TEXTURE_RECTANGLE, GL_PROXY_TEXTURE_2D_MULTISAMPLE,
 *      GL_PROXY_TEXTURE_2D_MULTISAMPLE_ARRAY, GL_PROXY_TEXTURE_CUBE_MAP, or GL_TEXTURE_BUFFER.
 *  @param[in] level Specifies the level-of-detail number of the desired image. Level 0 is the base
 *      image level. Level n is the nth mipmap reduction image.
 *  @param[in] pname Specifies the symbolic name of a texture parameter. GL_TEXTURE_WIDTH,
 *      GL_TEXTURE_HEIGHT, GL_TEXTURE_DEPTH, GL_TEXTURE_INTERNAL_FORMAT, GL_TEXTURE_BORDER,
 *      GL_TEXTURE_RED_SIZE, GL_TEXTURE_GREEN_SIZE, GL_TEXTURE_BLUE_SIZE, GL_TEXTURE_ALPHA_SIZE,
 *      GL_TEXTURE_DEPTH_SIZE, GL_TEXTURE_COMPRESSED, and GL_TEXTURE_COMPRESSED_IMAGE_SIZE are accepted.
 *  @param[out] params Returns the requested data.
 */
GLStaticApi void ApiEntry glGetTexLevelParameteriv(GLenum target, int level, GLenum pname, int *params);

/**
 *  @brief test whether a capability is enabled
 *  @param[in] cap Specifies a symbolic constant indicating a GL capability.
 */
GLStaticApi GLboolean ApiEntry glIsEnabled(GLenum cap);

/**
 *  @brief specify mapping of depth values from normalized device coordinates to window coordinates
 *  @param[in] nearVal Specifies the mapping of the near clipping plane to window coordinates. The
 *      initial value is 0.
 *  @param[in] farVal Specifies the mapping of the far clipping plane to window coordinates. The
 *      initial value is 1.
 */
GLStaticApi void ApiEntry glDepthRange(GLclampd nearVal, GLclampd farVal);

/**
 *  @brief set the viewport
 *  @param[in] x Specify the lower left corner of the viewport rectangle, in pixels. The initial
 *      value is (0,0).
 *  @param[in] y Specify the lower left corner of the viewport rectangle, in pixels. The initial
 *      value is (0,0).
 *  @param[in] width Specify the width and height of the viewport. When a GL context is first
 *      attached to a window, width and height are set to the dimensions of that window.
 *  @param[in] height Specify the width and height of the viewport. When a GL context is first
 *      attached to a window, width and height are set to the dimensions of that window.
 */
GLStaticApi void ApiEntry glViewport(int x, int y, GLsizei width, GLsizei height);

#ifdef __cplusplus
}
#endif

#ifdef __HAVE_GL_AUTOCHECK

inline void glCullFace_glachwrap(GLenum mode) { glCullFace(mode); }
inline void glFrontFace_glachwrap(GLenum mode) { glFrontFace(mode); }
inline void glHint_glachwrap(GLenum target, GLenum mode) { glHint(target,mode); }
inline void glLineWidth_glachwrap(float width) { glLineWidth(width); }
inline void glPointSize_glachwrap(float size) { glPointSize(size); }
inline void glPolygonMode_glachwrap(GLenum face, GLenum mode) { glPolygonMode(face,mode); }
inline void glScissor_glachwrap(int x, int y, GLsizei width, GLsizei height) { glScissor(x,y,width,height); }
inline void glTexParameterf_glachwrap(GLenum target, GLenum pname, float param) { glTexParameterf(target,pname,param); }
inline void glTexParameterfv_glachwrap(GLenum target, GLenum pname, const float *params) { glTexParameterfv(target,pname,params); }
inline void glTexParameteri_glachwrap(GLenum target, GLenum pname, int param) { glTexParameteri(target,pname,param); }
inline void glTexParameteriv_glachwrap(GLenum target, GLenum pname, const int *params) { glTexParameteriv(target,pname,params); }
inline void glTexImage1D_glachwrap(GLenum target, int level, int internalFormat, GLsizei width, int border, GLenum format, GLenum type, const void *data) { glTexImage1D(target,level,internalFormat,width,border,format,type,data); }
inline void glTexImage2D_glachwrap(GLenum target, int level, int internalFormat, GLsizei width, GLsizei height, int border, GLenum format, GLenum type, const void *data) { glTexImage2D(target,level,internalFormat,width,height,border,format,type,data); }
inline void glDrawBuffer_glachwrap(GLenum mode) { glDrawBuffer(mode); }
inline void glClear_glachwrap(GLbitfield mask) { glClear(mask); }
inline void glClearColor_glachwrap(GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha) { glClearColor(red,green,blue,alpha); }
inline void glClearStencil_glachwrap(int s) { glClearStencil(s); }
inline void glClearDepth_glachwrap(GLclampd depth) { glClearDepth(depth); }
inline void glStencilMask_glachwrap(GLuint mask) { glStencilMask(mask); }
inline void glColorMask_glachwrap(GLboolean red, GLboolean green, GLboolean blue, GLboolean alpha) { glColorMask(red,green,blue,alpha); }
inline void glDepthMask_glachwrap(GLboolean flag) { glDepthMask(flag); }
inline void glDisable_glachwrap(GLenum cap) { glDisable(cap); }
inline void glEnable_glachwrap(GLenum cap) { glEnable(cap); }
inline void glFinish_glachwrap() { glFinish(); }
inline void glFlush_glachwrap() { glFlush(); }
inline void glBlendFunc_glachwrap(GLenum sfactor, GLenum dfactor) { glBlendFunc(sfactor,dfactor); }
inline void glLogicOp_glachwrap(GLenum opcode) { glLogicOp(opcode); }
inline void glStencilFunc_glachwrap(GLenum func, int ref, GLuint mask) { glStencilFunc(func,ref,mask); }
inline void glStencilOp_glachwrap(GLenum sfail, GLenum dpfail, GLenum dppass) { glStencilOp(sfail,dpfail,dppass); }
inline void glDepthFunc_glachwrap(GLenum func) { glDepthFunc(func); }
inline void glPixelStoref_glachwrap(GLenum pname, float param) { glPixelStoref(pname,param); }
inline void glPixelStorei_glachwrap(GLenum pname, int param) { glPixelStorei(pname,param); }
inline void glReadBuffer_glachwrap(GLenum mode) { glReadBuffer(mode); }
inline void glReadPixels_glachwrap(int x, int y, GLsizei width, GLsizei height, GLenum format, GLenum type, void *data) { glReadPixels(x,y,width,height,format,type,data); }
inline void glGetBooleanv_glachwrap(GLenum pname, GLboolean *params) { glGetBooleanv(pname,params); }
inline void glGetDoublev_glachwrap(GLenum pname, double *params) { glGetDoublev(pname,params); }
//inline GLenum glGetError_glachwrap(const char *p_s_filename, int n_line) { GLenum result = glGetError(); GL_AUTOCHECK_BLOCK("glGetError", p_s_filename, n_line); return result; }
inline void glGetFloatv_glachwrap(GLenum pname, float *params) { glGetFloatv(pname,params); }
inline void glGetIntegerv_glachwrap(GLenum pname, int *params) { glGetIntegerv(pname,params); }
inline const GLubyte *glGetString_glachwrap(GLenum name, const char *p_s_filename, int n_line) { const GLubyte *result = glGetString(name); GL_AUTOCHECK_BLOCK("glGetString", p_s_filename, n_line); return result; }
inline void glGetTexImage_glachwrap(GLenum target, int level, GLenum format, GLenum type, void *img) { glGetTexImage(target,level,format,type,img); }
inline void glGetTexParameterfv_glachwrap(GLenum target, GLenum pname, float *params) { glGetTexParameterfv(target,pname,params); }
inline void glGetTexParameteriv_glachwrap(GLenum target, GLenum pname, int *params) { glGetTexParameteriv(target,pname,params); }
inline void glGetTexLevelParameterfv_glachwrap(GLenum target, int level, GLenum pname, float *params) { glGetTexLevelParameterfv(target,level,pname,params); }
inline void glGetTexLevelParameteriv_glachwrap(GLenum target, int level, GLenum pname, int *params) { glGetTexLevelParameteriv(target,level,pname,params); }
inline GLboolean glIsEnabled_glachwrap(GLenum cap, const char *p_s_filename, int n_line) { GLboolean result = glIsEnabled(cap); GL_AUTOCHECK_BLOCK("glIsEnabled", p_s_filename, n_line); return result; }
inline void glDepthRange_glachwrap(GLclampd nearVal, GLclampd farVal) { glDepthRange(nearVal,farVal); }
inline void glViewport_glachwrap(int x, int y, GLsizei width, GLsizei height) { glViewport(x,y,width,height); }

/**
 *  @def glCullFace
 *  @brief specify whether front- or back-facing facets can be culled
 *  @param[in] mode Specifies whether front- or back-facing facets are candidates for culling.
 *      Symbolic constants GL_FRONT, GL_BACK, and GL_FRONT_AND_BACK are accepted. The initial value
 *      is GL_BACK.
 */
#define glCullFace(mode) do { glCullFace_glachwrap(mode); GL_AUTOCHECK_BLOCK("glCullFace", __FILE__, __LINE__); } while(0)

/**
 *  @def glFrontFace
 *  @brief define front- and back-facing polygons
 *  @param[in] mode Specifies the orientation of front-facing polygons. GL_CW and GL_CCW are
 *      accepted. The initial value is GL_CCW.
 */
#define glFrontFace(mode) do { glFrontFace_glachwrap(mode); GL_AUTOCHECK_BLOCK("glFrontFace", __FILE__, __LINE__); } while(0)

/**
 *  @def glHint
 *  @brief specify implementation-specific hints
 *  @param[in] target Specifies a symbolic constant indicating the behavior to be controlled.
 *      GL_LINE_SMOOTH_HINT, GL_POLYGON_SMOOTH_HINT, GL_TEXTURE_COMPRESSION_HINT, and
 *      GL_FRAGMENT_SHADER_DERIVATIVE_HINT are accepted.
 *  @param[in] mode Specifies a symbolic constant indicating the desired behavior. GL_FASTEST,
 *      GL_NICEST, and GL_DONT_CARE are accepted.
 */
#define glHint(target,mode) do { glHint_glachwrap(target, mode); GL_AUTOCHECK_BLOCK("glHint", __FILE__, __LINE__); } while(0)

/**
 *  @def glLineWidth
 *  @brief specify the width of rasterized lines
 *  @param[in] width Specifies the width of rasterized lines. The initial value is 1.
 */
#define glLineWidth(width) do { glLineWidth_glachwrap(width); GL_AUTOCHECK_BLOCK("glLineWidth", __FILE__, __LINE__); } while(0)

/**
 *  @def glPointSize
 *  @brief specify the diameter of rasterized points
 *  @param[in] size Specifies the diameter of rasterized points. The initial value is 1.
 */
#define glPointSize(size) do { glPointSize_glachwrap(size); GL_AUTOCHECK_BLOCK("glPointSize", __FILE__, __LINE__); } while(0)

/**
 *  @def glPolygonMode
 *  @brief select a polygon rasterization mode
 *  @param[in] face Specifies the polygons that mode applies to. Must be GL_FRONT_AND_BACK for
 *      front- and back-facing polygons.
 *  @param[in] mode Specifies how polygons will be rasterized. Accepted values are GL_POINT,
 *      GL_LINE, and GL_FILL. The initial value is GL_FILL for both front- and back-facing polygons.
 */
#define glPolygonMode(face,mode) do { glPolygonMode_glachwrap(face, mode); GL_AUTOCHECK_BLOCK("glPolygonMode", __FILE__, __LINE__); } while(0)

/**
 *  @def glScissor
 *  @brief define the scissor box
 *  @param[in] x Specify the lower left corner of the scissor box. Initially (0, 0).
 *  @param[in] y Specify the lower left corner of the scissor box. Initially (0, 0).
 *  @param[in] width Specify the width and height of the scissor box. When a GL context is first
 *      attached to a window, width and height are set to the dimensions of that window.
 *  @param[in] height Specify the width and height of the scissor box. When a GL context is first
 *      attached to a window, width and height are set to the dimensions of that window.
 */
#define glScissor(x,y,width,height) do { glScissor_glachwrap(x, y, width, height); GL_AUTOCHECK_BLOCK("glScissor", __FILE__, __LINE__); } while(0)

/**
 *  @def glTexParameterf
 *  @brief set texture parameters
 *  @param[in] target Specifies the target texture, which must be either GL_TEXTURE_1D,
 *      GL_TEXTURE_2D, GL_TEXTURE_3D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY,
 *      GL_TEXTURE_RECTANGLE, or GL_TEXTURE_CUBE_MAP.
 *  @param[in] pname Specifies the symbolic name of a single-valued texture parameter. pname can be
 *      one of the following: GL_TEXTURE_BASE_LEVEL, GL_TEXTURE_COMPARE_FUNC,
 *      GL_TEXTURE_COMPARE_MODE, GL_TEXTURE_LOD_BIAS, GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MAG_FILTER,
 *      GL_TEXTURE_MIN_LOD, GL_TEXTURE_MAX_LOD, GL_TEXTURE_MAX_LEVEL, GL_TEXTURE_SWIZZLE_R,
 *      GL_TEXTURE_SWIZZLE_G, GL_TEXTURE_SWIZZLE_B, GL_TEXTURE_SWIZZLE_A, GL_TEXTURE_WRAP_S,
 *      GL_TEXTURE_WRAP_T, or GL_TEXTURE_WRAP_R.
 *  @param[in] param Specifies the value of pname.
 */
#define glTexParameterf(target,pname,param) do { glTexParameterf_glachwrap(target, pname, param); GL_AUTOCHECK_BLOCK("glTexParameterf", __FILE__, __LINE__); } while(0)

/**
 *  @def glTexParameterfv
 *  @brief set texture parameters
 *  @param[in] target Specifies the target texture, which must be either GL_TEXTURE_1D,
 *      GL_TEXTURE_2D, GL_TEXTURE_3D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY,
 *      GL_TEXTURE_RECTANGLE, or GL_TEXTURE_CUBE_MAP.
 *  @param[in] pname Specifies the symbolic name of a texture parameter. pname can be one of the
 *      following: GL_TEXTURE_BASE_LEVEL, GL_TEXTURE_BORDER_COLOR, GL_TEXTURE_COMPARE_FUNC,
 *      GL_TEXTURE_COMPARE_MODE, GL_TEXTURE_LOD_BIAS, GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MAG_FILTER,
 *      GL_TEXTURE_MIN_LOD, GL_TEXTURE_MAX_LOD, GL_TEXTURE_MAX_LEVEL, GL_TEXTURE_SWIZZLE_R,
 *      GL_TEXTURE_SWIZZLE_G, GL_TEXTURE_SWIZZLE_B, GL_TEXTURE_SWIZZLE_A, GL_TEXTURE_SWIZZLE_RGBA,
 *      GL_TEXTURE_WRAP_S, GL_TEXTURE_WRAP_T, or GL_TEXTURE_WRAP_R.
 *  @param[in] params Specifies a pointer to an array where the value or values of pname are stored.
 */
#define glTexParameterfv(target,pname,params) do { glTexParameterfv_glachwrap(target, pname, params); GL_AUTOCHECK_BLOCK("glTexParameterfv", __FILE__, __LINE__); } while(0)

/**
 *  @def glTexParameteri
 *  @brief set texture parameters
 *  @param[in] target Specifies the target texture, which must be either GL_TEXTURE_1D,
 *      GL_TEXTURE_2D, GL_TEXTURE_3D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY,
 *      GL_TEXTURE_RECTANGLE, or GL_TEXTURE_CUBE_MAP.
 *  @param[in] pname Specifies the symbolic name of a single-valued texture parameter. pname can be
 *      one of the following: GL_TEXTURE_BASE_LEVEL, GL_TEXTURE_COMPARE_FUNC,
 *      GL_TEXTURE_COMPARE_MODE, GL_TEXTURE_LOD_BIAS, GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MAG_FILTER,
 *      GL_TEXTURE_MIN_LOD, GL_TEXTURE_MAX_LOD, GL_TEXTURE_MAX_LEVEL, GL_TEXTURE_SWIZZLE_R,
 *      GL_TEXTURE_SWIZZLE_G, GL_TEXTURE_SWIZZLE_B, GL_TEXTURE_SWIZZLE_A, GL_TEXTURE_WRAP_S,
 *      GL_TEXTURE_WRAP_T, or GL_TEXTURE_WRAP_R.
 *  @param[in] param Specifies the value of pname.
 */
#define glTexParameteri(target,pname,param) do { glTexParameteri_glachwrap(target, pname, param); GL_AUTOCHECK_BLOCK("glTexParameteri", __FILE__, __LINE__); } while(0)

/**
 *  @def glTexParameteriv
 *  @brief set texture parameters
 *  @param[in] target Specifies the target texture, which must be either GL_TEXTURE_1D,
 *      GL_TEXTURE_2D, GL_TEXTURE_3D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY,
 *      GL_TEXTURE_RECTANGLE, or GL_TEXTURE_CUBE_MAP.
 *  @param[in] pname Specifies the symbolic name of a texture parameter. pname can be one of the
 *      following: GL_TEXTURE_BASE_LEVEL, GL_TEXTURE_BORDER_COLOR, GL_TEXTURE_COMPARE_FUNC,
 *      GL_TEXTURE_COMPARE_MODE, GL_TEXTURE_LOD_BIAS, GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MAG_FILTER,
 *      GL_TEXTURE_MIN_LOD, GL_TEXTURE_MAX_LOD, GL_TEXTURE_MAX_LEVEL, GL_TEXTURE_SWIZZLE_R,
 *      GL_TEXTURE_SWIZZLE_G, GL_TEXTURE_SWIZZLE_B, GL_TEXTURE_SWIZZLE_A, GL_TEXTURE_SWIZZLE_RGBA,
 *      GL_TEXTURE_WRAP_S, GL_TEXTURE_WRAP_T, or GL_TEXTURE_WRAP_R.
 *  @param[in] params Specifies a pointer to an array where the value or values of pname are stored.
 */
#define glTexParameteriv(target,pname,params) do { glTexParameteriv_glachwrap(target, pname, params); GL_AUTOCHECK_BLOCK("glTexParameteriv", __FILE__, __LINE__); } while(0)

/**
 *  @def glTexImage1D
 *  @brief specify a one-dimensional texture image
 *  @param[in] target Specifies the target texture. Must be GL_TEXTURE_1D or GL_PROXY_TEXTURE_1D.
 *  @param[in] level Specifies the level-of-detail number. Level 0 is the base image level. Level n
 *      is the nth mipmap reduction image.
 *  @param[in] internalFormat Specifies the number of color components in the texture. Must be one
 *      of the following symbolic constants: GL_COMPRESSED_RED, GL_COMPRESSED_RG, GL_COMPRESSED_RGB,
 *      GL_COMPRESSED_RGBA, GL_COMPRESSED_SRGB, GL_COMPRESSED_SRGB_ALPHA, GL_DEPTH_COMPONENT,
 *      GL_DEPTH_COMPONENT16, GL_DEPTH_COMPONENT24, GL_DEPTH_COMPONENT32, GL_R3_G3_B2, GL_RED,
 *      GL_RG, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2,
 *      GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, GL_RGBA16, GL_SRGB, GL_SRGB8,
 *      GL_SRGB_ALPHA, or GL_SRGB8_ALPHA8.
 *  @param[in] width Specifies the width of the texture image. All implementations support texture
 *      images that are at least 1024 texels wide. The height of the 1D texture image is 1.
 *  @param[in] border This value must be 0.
 *  @param[in] format Specifies the format of the pixel data. The following symbolic values are
 *      accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, and GL_BGRA.
 *  @param[in] type Specifies the data type of the pixel data. The following symbolic values are
 *      accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT,
 *      GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5,
 *      GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV,
 *      GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8,
 *      GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
 *  @param[in] data Specifies a pointer to the image data in memory.
 */
#define glTexImage1D(target,level,internalFormat,width,border,format,type,data) do { glTexImage1D_glachwrap(target, level, internalFormat, width, border, format, type, data); GL_AUTOCHECK_BLOCK("glTexImage1D", __FILE__, __LINE__); } while(0)

/**
 *  @def glTexImage2D
 *  @brief specify a two-dimensional texture image
 *  @param[in] target Specifies the target texture. Must be GL_TEXTURE_2D, GL_PROXY_TEXTURE_2D,
 *      GL_TEXTURE_1D_ARRAY, GL_PROXY_TEXTURE_1D_ARRAY, GL_TEXTURE_RECTANGLE,
 *      GL_PROXY_TEXTURE_RECTANGLE, GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X,
 *      GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y,
 *      GL_TEXTURE_CUBE_MAP_POSITIVE_Z, GL_TEXTURE_CUBE_MAP_NEGATIVE_Z, or GL_PROXY_TEXTURE_CUBE_MAP.
 *  @param[in] level Specifies the level-of-detail number. Level 0 is the base image level. Level n
 *      is the nth mipmap reduction image. If target is GL_TEXTURE_RECTANGLE or
 *      GL_PROXY_TEXTURE_RECTANGLE, level must be 0.
 *  @param[in] internalFormat Specifies the number of color components in the texture. Must be one
 *      of the following symbolic constants: GL_COMPRESSED_RED, GL_COMPRESSED_RG, GL_COMPRESSED_RGB,
 *      GL_COMPRESSED_RGBA, GL_COMPRESSED_SRGB, GL_COMPRESSED_SRGB_ALPHA, GL_DEPTH_COMPONENT,
 *      GL_DEPTH_COMPONENT16, GL_DEPTH_COMPONENT24, GL_DEPTH_COMPONENT32, GL_R3_G3_B2, GL_RED,
 *      GL_RG, GL_RGB, GL_RGB4, GL_RGB5, GL_RGB8, GL_RGB10, GL_RGB12, GL_RGB16, GL_RGBA, GL_RGBA2,
 *      GL_RGBA4, GL_RGB5_A1, GL_RGBA8, GL_RGB10_A2, GL_RGBA12, GL_RGBA16, GL_SRGB, GL_SRGB8,
 *      GL_SRGB_ALPHA, or GL_SRGB8_ALPHA8.
 *  @param[in] width Specifies the width of the texture image. All implementations support texture
 *      images that are at least 1024 texels wide.
 *  @param[in] height Specifies the height of the texture image, or the number of layers in a
 *      texture array, in the case of the GL_TEXTURE_1D_ARRAY and GL_PROXY_TEXTURE_1D_ARRAY targets.
 *      All implementations support 2D texture images that are at least 1024 texels high, and
 *      texture arrays that are at least 256 layers deep.
 *  @param[in] border This value must be 0.
 *  @param[in] format Specifies the format of the pixel data. The following symbolic values are
 *      accepted: GL_RED, GL_RG, GL_RGB, GL_BGR, GL_RGBA, and GL_BGRA.
 *  @param[in] type Specifies the data type of the pixel data. The following symbolic values are
 *      accepted: GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT,
 *      GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5,
 *      GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV,
 *      GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8,
 *      GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, and GL_UNSIGNED_INT_2_10_10_10_REV.
 *  @param[in] data Specifies a pointer to the image data in memory.
 */
#define glTexImage2D(target,level,internalFormat,width,height,border,format,type,data) do { glTexImage2D_glachwrap(target, level, internalFormat, width, height, border, format, type, data); GL_AUTOCHECK_BLOCK("glTexImage2D", __FILE__, __LINE__); } while(0)

/**
 *  @def glDrawBuffer
 *  @brief specify which color buffers are to be drawn into
 *  @param[in] mode Specifies up to four color buffers to be drawn into. Symbolic constants GL_NONE,
 *      GL_FRONT_LEFT, GL_FRONT_RIGHT, GL_BACK_LEFT, GL_BACK_RIGHT, GL_FRONT, GL_BACK, GL_LEFT,
 *      GL_RIGHT, and GL_FRONT_AND_BACK are accepted. The initial value is GL_FRONT for
 *      single-buffered contexts, and GL_BACK for double-buffered contexts.
 */
#define glDrawBuffer(mode) do { glDrawBuffer_glachwrap(mode); GL_AUTOCHECK_BLOCK("glDrawBuffer", __FILE__, __LINE__); } while(0)

/**
 *  @def glClear
 *  @brief clear buffers to preset values
 *  @param[in] mask Bitwise OR of masks that indicate the buffers to be cleared. The three masks are
 *      GL_COLOR_BUFFER_BIT, GL_DEPTH_BUFFER_BIT, and GL_STENCIL_BUFFER_BIT.
 */
#define glClear(mask) do { glClear_glachwrap(mask); GL_AUTOCHECK_BLOCK("glClear", __FILE__, __LINE__); } while(0)

/**
 *  @def glClearColor
 *  @brief specify clear values for the color buffers
 *  @param[in] red Specify the red, green, blue, and alpha values used when the color buffers are
 *      cleared. The initial values are all 0.
 *  @param[in] green Specify the red, green, blue, and alpha values used when the color buffers are
 *      cleared. The initial values are all 0.
 *  @param[in] blue Specify the red, green, blue, and alpha values used when the color buffers are
 *      cleared. The initial values are all 0.
 *  @param[in] alpha Specify the red, green, blue, and alpha values used when the color buffers are
 *      cleared. The initial values are all 0.
 */
#define glClearColor(red,green,blue,alpha) do { glClearColor_glachwrap(red, green, blue, alpha); GL_AUTOCHECK_BLOCK("glClearColor", __FILE__, __LINE__); } while(0)

/**
 *  @def glClearStencil
 *  @brief specify the clear value for the stencil buffer
 *  @param[in] s Specifies the index used when the stencil buffer is cleared. The initial value is 0.
 */
#define glClearStencil(s) do { glClearStencil_glachwrap(s); GL_AUTOCHECK_BLOCK("glClearStencil", __FILE__, __LINE__); } while(0)

/**
 *  @def glClearDepth
 *  @brief specify the clear value for the depth buffer
 *  @param[in] depth Specifies the depth value used when the depth buffer is cleared. The initial
 *      value is 1.
 */
#define glClearDepth(depth) do { glClearDepth_glachwrap(depth); GL_AUTOCHECK_BLOCK("glClearDepth", __FILE__, __LINE__); } while(0)

/**
 *  @def glStencilMask
 *  @brief control the front and back writing of individual bits in the stencil planes
 *  @param[in] mask Specifies a bit mask to enable and disable writing of individual bits in the
 *      stencil planes. Initially, the mask is all 1's.
 */
#define glStencilMask(mask) do { glStencilMask_glachwrap(mask); GL_AUTOCHECK_BLOCK("glStencilMask", __FILE__, __LINE__); } while(0)

/**
 *  @def glColorMask
 *  @brief enable and disable writing of frame buffer color components
 *  @param[in] red Specify whether red, green, blue, and alpha are to be written into the frame
 *      buffer. The initial values are all GL_TRUE, indicating that the color components are written.
 *  @param[in] green Specify whether red, green, blue, and alpha are to be written into the frame
 *      buffer. The initial values are all GL_TRUE, indicating that the color components are written.
 *  @param[in] blue Specify whether red, green, blue, and alpha are to be written into the frame
 *      buffer. The initial values are all GL_TRUE, indicating that the color components are written.
 *  @param[in] alpha Specify whether red, green, blue, and alpha are to be written into the frame
 *      buffer. The initial values are all GL_TRUE, indicating that the color components are written.
 */
#define glColorMask(red,green,blue,alpha) do { glColorMask_glachwrap(red, green, blue, alpha); GL_AUTOCHECK_BLOCK("glColorMask", __FILE__, __LINE__); } while(0)

/**
 *  @def glDepthMask
 *  @brief enable or disable writing into the depth buffer
 *  @param[in] flag Specifies whether the depth buffer is enabled for writing. If flag is GL_FALSE,
 *      depth buffer writing is disabled. Otherwise, it is enabled. Initially, depth buffer writing
 *      is enabled.
 */
#define glDepthMask(flag) do { glDepthMask_glachwrap(flag); GL_AUTOCHECK_BLOCK("glDepthMask", __FILE__, __LINE__); } while(0)

/**
 *  @def glDisable
 *  @brief enable or disable server-side GL capabilities
 *  @param[in] cap Specifies a symbolic constant indicating a GL capability.
 */
#define glDisable(cap) do { glDisable_glachwrap(cap); GL_AUTOCHECK_BLOCK("glDisable", __FILE__, __LINE__); } while(0)

/**
 *  @def glEnable
 *  @brief enable or disable server-side GL capabilities
 *  @param[in] cap Specifies a symbolic constant indicating a GL capability.
 */
#define glEnable(cap) do { glEnable_glachwrap(cap); GL_AUTOCHECK_BLOCK("glEnable", __FILE__, __LINE__); } while(0)

/**
 *  @def glFinish
 *  @brief block until all GL execution is complete
 */
#define glFinish() do { glFinish_glachwrap(); GL_AUTOCHECK_BLOCK("glFinish", __FILE__, __LINE__); } while(0)

/**
 *  @def glFlush
 *  @brief force execution of GL commands in finite time
 */
#define glFlush() do { glFlush_glachwrap(); GL_AUTOCHECK_BLOCK("glFlush", __FILE__, __LINE__); } while(0)

/**
 *  @def glBlendFunc
 *  @brief specify pixel arithmetic
 *  @param[in] sfactor Specifies how the red, green, blue, and alpha source blending factors are
 *      computed. The initial value is GL_ONE.
 *  @param[in] dfactor Specifies how the red, green, blue, and alpha destination blending factors
 *      are computed. The following symbolic constants are accepted: GL_ZERO, GL_ONE, GL_SRC_COLOR,
 *      GL_ONE_MINUS_SRC_COLOR, GL_DST_COLOR, GL_ONE_MINUS_DST_COLOR, GL_SRC_ALPHA,
 *      GL_ONE_MINUS_SRC_ALPHA, GL_DST_ALPHA, GL_ONE_MINUS_DST_ALPHA. GL_CONSTANT_COLOR,
 *      GL_ONE_MINUS_CONSTANT_COLOR, GL_CONSTANT_ALPHA, and GL_ONE_MINUS_CONSTANT_ALPHA. The initial
 *      value is GL_ZERO.
 */
#define glBlendFunc(sfactor,dfactor) do { glBlendFunc_glachwrap(sfactor, dfactor); GL_AUTOCHECK_BLOCK("glBlendFunc", __FILE__, __LINE__); } while(0)

/**
 *  @def glLogicOp
 *  @brief specify a logical pixel operation for rendering
 *  @param[in] opcode Specifies a symbolic constant that selects a logical operation. The following
 *      symbols are accepted: GL_CLEAR, GL_SET, GL_COPY, GL_COPY_INVERTED, GL_NOOP, GL_INVERT,
 *      GL_AND, GL_NAND, GL_OR, GL_NOR, GL_XOR, GL_EQUIV, GL_AND_REVERSE, GL_AND_INVERTED,
 *      GL_OR_REVERSE, and GL_OR_INVERTED. The initial value is GL_COPY.
 */
#define glLogicOp(opcode) do { glLogicOp_glachwrap(opcode); GL_AUTOCHECK_BLOCK("glLogicOp", __FILE__, __LINE__); } while(0)

/**
 *  @def glStencilFunc
 *  @brief set front and back function and reference value for stencil testing
 *  @param[in] func Specifies the test function. Eight symbolic constants are valid: GL_NEVER,
 *      GL_LESS, GL_LEQUAL, GL_GREATER, GL_GEQUAL, GL_EQUAL, GL_NOTEQUAL, and GL_ALWAYS. The initial
 *      value is GL_ALWAYS.
 *  @param[in] ref Specifies the reference value for the stencil test. ref is clamped to the range 0
 *      2 n - 1, where n is the number of bitplanes in the stencil buffer. The initial value is 0.
 *  @param[in] mask Specifies a mask that is ANDed with both the reference value and the stored
 *      stencil value when the test is done. The initial value is all 1's.
 */
#define glStencilFunc(func,ref,mask) do { glStencilFunc_glachwrap(func, ref, mask); GL_AUTOCHECK_BLOCK("glStencilFunc", __FILE__, __LINE__); } while(0)

/**
 *  @def glStencilOp
 *  @brief set front and back stencil test actions
 *  @param[in] sfail Specifies the action to take when the stencil test fails. Eight symbolic
 *      constants are accepted: GL_KEEP, GL_ZERO, GL_REPLACE, GL_INCR, GL_INCR_WRAP, GL_DECR,
 *      GL_DECR_WRAP, and GL_INVERT. The initial value is GL_KEEP.
 *  @param[in] dpfail Specifies the stencil action when the stencil test passes, but the depth test
 *      fails. dpfail accepts the same symbolic constants as sfail. The initial value is GL_KEEP.
 *  @param[in] dppass Specifies the stencil action when both the stencil test and the depth test
 *      pass, or when the stencil test passes and either there is no depth buffer or depth testing
 *      is not enabled. dppass accepts the same symbolic constants as sfail. The initial value is GL_KEEP.
 */
#define glStencilOp(sfail,dpfail,dppass) do { glStencilOp_glachwrap(sfail, dpfail, dppass); GL_AUTOCHECK_BLOCK("glStencilOp", __FILE__, __LINE__); } while(0)

/**
 *  @def glDepthFunc
 *  @brief specify the value used for depth buffer comparisons
 *  @param[in] func Specifies the depth comparison function. Symbolic constants GL_NEVER, GL_LESS,
 *      GL_EQUAL, GL_LEQUAL, GL_GREATER, GL_NOTEQUAL, GL_GEQUAL, and GL_ALWAYS are accepted. The
 *      initial value is GL_LESS.
 */
#define glDepthFunc(func) do { glDepthFunc_glachwrap(func); GL_AUTOCHECK_BLOCK("glDepthFunc", __FILE__, __LINE__); } while(0)

/**
 *  @def glPixelStoref
 *  @brief set pixel storage modes
 *  @param[in] pname Specifies the symbolic name of the parameter to be set. Six values affect the
 *      packing of pixel data into memory: GL_PACK_SWAP_BYTES, GL_PACK_LSB_FIRST,
 *      GL_PACK_ROW_LENGTH, GL_PACK_IMAGE_HEIGHT, GL_PACK_SKIP_PIXELS, GL_PACK_SKIP_ROWS,
 *      GL_PACK_SKIP_IMAGES, and GL_PACK_ALIGNMENT. Six more affect the unpacking of pixel data from
 *      memory: GL_UNPACK_SWAP_BYTES, GL_UNPACK_LSB_FIRST, GL_UNPACK_ROW_LENGTH,
 *      GL_UNPACK_IMAGE_HEIGHT, GL_UNPACK_SKIP_PIXELS, GL_UNPACK_SKIP_ROWS, GL_UNPACK_SKIP_IMAGES,
 *      and GL_UNPACK_ALIGNMENT.
 *  @param[in] param Specifies the value that pname is set to.
 */
#define glPixelStoref(pname,param) do { glPixelStoref_glachwrap(pname, param); GL_AUTOCHECK_BLOCK("glPixelStoref", __FILE__, __LINE__); } while(0)

/**
 *  @def glPixelStorei
 *  @brief set pixel storage modes
 *  @param[in] pname Specifies the symbolic name of the parameter to be set. Six values affect the
 *      packing of pixel data into memory: GL_PACK_SWAP_BYTES, GL_PACK_LSB_FIRST,
 *      GL_PACK_ROW_LENGTH, GL_PACK_IMAGE_HEIGHT, GL_PACK_SKIP_PIXELS, GL_PACK_SKIP_ROWS,
 *      GL_PACK_SKIP_IMAGES, and GL_PACK_ALIGNMENT. Six more affect the unpacking of pixel data from
 *      memory: GL_UNPACK_SWAP_BYTES, GL_UNPACK_LSB_FIRST, GL_UNPACK_ROW_LENGTH,
 *      GL_UNPACK_IMAGE_HEIGHT, GL_UNPACK_SKIP_PIXELS, GL_UNPACK_SKIP_ROWS, GL_UNPACK_SKIP_IMAGES,
 *      and GL_UNPACK_ALIGNMENT.
 *  @param[in] param Specifies the value that pname is set to.
 */
#define glPixelStorei(pname,param) do { glPixelStorei_glachwrap(pname, param); GL_AUTOCHECK_BLOCK("glPixelStorei", __FILE__, __LINE__); } while(0)

/**
 *  @def glReadBuffer
 *  @brief select a color buffer source for pixels
 *  @param[in] mode Specifies a color buffer. Accepted values are GL_FRONT_LEFT, GL_FRONT_RIGHT,
 *      GL_BACK_LEFT, GL_BACK_RIGHT, GL_FRONT, GL_BACK, GL_LEFT, and GL_RIGHT.
 */
#define glReadBuffer(mode) do { glReadBuffer_glachwrap(mode); GL_AUTOCHECK_BLOCK("glReadBuffer", __FILE__, __LINE__); } while(0)

/**
 *  @def glReadPixels
 *  @brief read a block of pixels from the frame buffer
 *  @param[in] x Specify the window coordinates of the first pixel that is read from the frame
 *      buffer. This location is the lower left corner of a rectangular block of pixels.
 *  @param[in] y Specify the window coordinates of the first pixel that is read from the frame
 *      buffer. This location is the lower left corner of a rectangular block of pixels.
 *  @param[in] width Specify the dimensions of the pixel rectangle. width and height of one
 *      correspond to a single pixel.
 *  @param[in] height Specify the dimensions of the pixel rectangle. width and height of one
 *      correspond to a single pixel.
 *  @param[in] format Specifies the format of the pixel data. The following symbolic values are
 *      accepted: GL_STENCIL_INDEX, GL_DEPTH_COMPONENT, GL_DEPTH_STENCIL, GL_RED, GL_GREEN, GL_BLUE,
 *      GL_RGB, GL_BGR, GL_RGBA, and GL_BGRA.
 *  @param[in] type Specifies the data type of the pixel data. Must be one of GL_UNSIGNED_BYTE,
 *      GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT, GL_HALF_FLOAT, GL_FLOAT,
 *      GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV, GL_UNSIGNED_SHORT_5_6_5,
 *      GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4, GL_UNSIGNED_SHORT_4_4_4_4_REV,
 *      GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV, GL_UNSIGNED_INT_8_8_8_8,
 *      GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2, GL_UNSIGNED_INT_2_10_10_10_REV,
 *      GL_UNSIGNED_INT_24_8, GL_UNSIGNED_INT_10F_11F_11F_REV, GL_UNSIGNED_INT_5_9_9_9_REV, or GL_FLOAT_32_UNSIGNED_INT_24_8_REV.
 *  @param[out] data Returns the pixel data.
 */
#define glReadPixels(x,y,width,height,format,type,data) do { glReadPixels_glachwrap(x, y, width, height, format, type, data); GL_AUTOCHECK_BLOCK("glReadPixels", __FILE__, __LINE__); } while(0)

/**
 *  @def glGetBooleanv
 *  @brief return the value or values of a selected parameter
 *  @param[in] pname Specifies the parameter value to be returned. The symbolic constants in the
 *      list below are accepted.
 *  @param[out] params Returns the value or values of the specified parameter.
 */
#define glGetBooleanv(pname,params) do { glGetBooleanv_glachwrap(pname, params); GL_AUTOCHECK_BLOCK("glGetBooleanv", __FILE__, __LINE__); } while(0)

/**
 *  @def glGetDoublev
 *  @brief return the value or values of a selected parameter
 *  @param[in] pname Specifies the parameter value to be returned. The symbolic constants in the
 *      list below are accepted.
 *  @param[out] params Returns the value or values of the specified parameter.
 */
#define glGetDoublev(pname,params) do { glGetDoublev_glachwrap(pname, params); GL_AUTOCHECK_BLOCK("glGetDoublev", __FILE__, __LINE__); } while(0)

/**
 *  @def glGetFloatv
 *  @brief return the value or values of a selected parameter
 *  @param[in] pname Specifies the parameter value to be returned. The symbolic constants in the
 *      list below are accepted.
 *  @param[out] params Returns the value or values of the specified parameter.
 */
#define glGetFloatv(pname,params) do { glGetFloatv_glachwrap(pname, params); GL_AUTOCHECK_BLOCK("glGetFloatv", __FILE__, __LINE__); } while(0)

/**
 *  @def glGetIntegerv
 *  @brief return the value or values of a selected parameter
 *  @param[in] pname Specifies the parameter value to be returned. The symbolic constants in the
 *      list below are accepted.
 *  @param[out] params Returns the value or values of the specified parameter.
 */
#define glGetIntegerv(pname,params) do { glGetIntegerv_glachwrap(pname, params); GL_AUTOCHECK_BLOCK("glGetIntegerv", __FILE__, __LINE__); } while(0)

/**
 *  @def glGetString
 *  @brief return a string describing the current GL connection
 *  @param[in] name Specifies a symbolic constant, one of GL_VENDOR, GL_RENDERER, GL_VERSION, or
 *      GL_SHADING_LANGUAGE_VERSION. Additionally, glGetStringi accepts the GL_EXTENSIONS token.
 */
#define glGetString(name) glGetString_glachwrap(name, __FILE__, __LINE__)

/**
 *  @def glGetTexImage
 *  @brief return a texture image
 *  @param[in] target Specifies which texture is to be obtained. GL_TEXTURE_1D, GL_TEXTURE_2D,
 *      GL_TEXTURE_3D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY, GL_TEXTURE_RECTANGLE,
 *      GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X,
 *      GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y,
 *      GL_TEXTURE_CUBE_MAP_POSITIVE_Z, and GL_TEXTURE_CUBE_MAP_NEGATIVE_Z are accepted.
 *  @param[in] level Specifies the level-of-detail number of the desired image. Level 0 is the base
 *      image level. Level n is the nth mipmap reduction image.
 *  @param[in] format Specifies a pixel format for the returned data. The supported formats are
 *      GL_STENCIL_INDEX, GL_DEPTH_COMPONENT, GL_DEPTH_STENCIL, GL_RED, GL_GREEN, GL_BLUE, GL_RG,
 *      GL_RGB, GL_RGBA, GL_BGR, GL_BGRA, GL_RED_INTEGER, GL_GREEN_INTEGER, GL_BLUE_INTEGER,
 *      GL_RG_INTEGER, GL_RGB_INTEGER, GL_RGBA_INTEGER, GL_BGR_INTEGER, GL_BGRA_INTEGER.
 *  @param[in] type Specifies a pixel type for the returned data. The supported types are
 *      GL_UNSIGNED_BYTE, GL_BYTE, GL_UNSIGNED_SHORT, GL_SHORT, GL_UNSIGNED_INT, GL_INT,
 *      GL_HALF_FLOAT, GL_FLOAT, GL_UNSIGNED_BYTE_3_3_2, GL_UNSIGNED_BYTE_2_3_3_REV,
 *      GL_UNSIGNED_SHORT_5_6_5, GL_UNSIGNED_SHORT_5_6_5_REV, GL_UNSIGNED_SHORT_4_4_4_4,
 *      GL_UNSIGNED_SHORT_4_4_4_4_REV, GL_UNSIGNED_SHORT_5_5_5_1, GL_UNSIGNED_SHORT_1_5_5_5_REV,
 *      GL_UNSIGNED_INT_8_8_8_8, GL_UNSIGNED_INT_8_8_8_8_REV, GL_UNSIGNED_INT_10_10_10_2,
 *      GL_UNSIGNED_INT_2_10_10_10_REV, GL_UNSIGNED_INT_24_8, GL_UNSIGNED_INT_10F_11F_11F_REV,
 *      GL_UNSIGNED_INT_5_9_9_9_REV, and GL_FLOAT_32_UNSIGNED_INT_24_8_REV.
 *  @param[out] img Returns the texture image. Should be a pointer to an array of the type specified
 *      by type.
 */
#define glGetTexImage(target,level,format,type,img) do { glGetTexImage_glachwrap(target, level, format, type, img); GL_AUTOCHECK_BLOCK("glGetTexImage", __FILE__, __LINE__); } while(0)

/**
 *  @def glGetTexParameterfv
 *  @brief return texture parameter values
 *  @param[in] target Specifies the symbolic name of the target texture. GL_TEXTURE_1D,
 *      GL_TEXTURE_2D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY, GL_TEXTURE_3D,
 *      GL_TEXTURE_RECTANGLE, and GL_TEXTURE_CUBE_MAP are accepted.
 *  @param[in] pname Specifies the symbolic name of a texture parameter. GL_TEXTURE_BASE_LEVEL,
 *      GL_TEXTURE_BORDER_COLOR, GL_TEXTURE_COMPARE_MODE, GL_TEXTURE_COMPARE_FUNC,
 *      GL_TEXTURE_LOD_BIAS, GL_TEXTURE_MAG_FILTER, GL_TEXTURE_MAX_LEVEL, GL_TEXTURE_MAX_LOD,
 *      GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MIN_LOD, GL_TEXTURE_SWIZZLE_R, GL_TEXTURE_SWIZZLE_G,
 *      GL_TEXTURE_SWIZZLE_B, GL_TEXTURE_SWIZZLE_A, GL_TEXTURE_SWIZZLE_RGBA, GL_TEXTURE_WRAP_S,
 *      GL_TEXTURE_WRAP_T, and GL_TEXTURE_WRAP_R are accepted.
 *  @param[out] params Returns the texture parameters.
 */
#define glGetTexParameterfv(target,pname,params) do { glGetTexParameterfv_glachwrap(target, pname, params); GL_AUTOCHECK_BLOCK("glGetTexParameterfv", __FILE__, __LINE__); } while(0)

/**
 *  @def glGetTexParameteriv
 *  @brief return texture parameter values
 *  @param[in] target Specifies the symbolic name of the target texture. GL_TEXTURE_1D,
 *      GL_TEXTURE_2D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY, GL_TEXTURE_3D,
 *      GL_TEXTURE_RECTANGLE, and GL_TEXTURE_CUBE_MAP are accepted.
 *  @param[in] pname Specifies the symbolic name of a texture parameter. GL_TEXTURE_BASE_LEVEL,
 *      GL_TEXTURE_BORDER_COLOR, GL_TEXTURE_COMPARE_MODE, GL_TEXTURE_COMPARE_FUNC,
 *      GL_TEXTURE_LOD_BIAS, GL_TEXTURE_MAG_FILTER, GL_TEXTURE_MAX_LEVEL, GL_TEXTURE_MAX_LOD,
 *      GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MIN_LOD, GL_TEXTURE_SWIZZLE_R, GL_TEXTURE_SWIZZLE_G,
 *      GL_TEXTURE_SWIZZLE_B, GL_TEXTURE_SWIZZLE_A, GL_TEXTURE_SWIZZLE_RGBA, GL_TEXTURE_WRAP_S,
 *      GL_TEXTURE_WRAP_T, and GL_TEXTURE_WRAP_R are accepted.
 *  @param[out] params Returns the texture parameters.
 */
#define glGetTexParameteriv(target,pname,params) do { glGetTexParameteriv_glachwrap(target, pname, params); GL_AUTOCHECK_BLOCK("glGetTexParameteriv", __FILE__, __LINE__); } while(0)

/**
 *  @def glGetTexLevelParameterfv
 *  @brief return texture parameter values for a specific level of detail
 *  @param[in] target Specifies the symbolic name of the target texture, one of GL_TEXTURE_1D,
 *      GL_TEXTURE_2D, GL_TEXTURE_3D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY,
 *      GL_TEXTURE_RECTANGLE, GL_TEXTURE_2D_MULTISAMPLE, GL_TEXTURE_2D_MULTISAMPLE_ARRAY,
 *      GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X,
 *      GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y,
 *      GL_TEXTURE_CUBE_MAP_POSITIVE_Z, GL_TEXTURE_CUBE_MAP_NEGATIVE_Z, GL_PROXY_TEXTURE_1D,
 *      GL_PROXY_TEXTURE_2D, GL_PROXY_TEXTURE_3D, GL_PROXY_TEXTURE_1D_ARRAY,
 *      GL_PROXY_TEXTURE_2D_ARRAY, GL_PROXY_TEXTURE_RECTANGLE, GL_PROXY_TEXTURE_2D_MULTISAMPLE,
 *      GL_PROXY_TEXTURE_2D_MULTISAMPLE_ARRAY, GL_PROXY_TEXTURE_CUBE_MAP, or GL_TEXTURE_BUFFER.
 *  @param[in] level Specifies the level-of-detail number of the desired image. Level 0 is the base
 *      image level. Level n is the nth mipmap reduction image.
 *  @param[in] pname Specifies the symbolic name of a texture parameter. GL_TEXTURE_WIDTH,
 *      GL_TEXTURE_HEIGHT, GL_TEXTURE_DEPTH, GL_TEXTURE_INTERNAL_FORMAT, GL_TEXTURE_BORDER,
 *      GL_TEXTURE_RED_SIZE, GL_TEXTURE_GREEN_SIZE, GL_TEXTURE_BLUE_SIZE, GL_TEXTURE_ALPHA_SIZE,
 *      GL_TEXTURE_DEPTH_SIZE, GL_TEXTURE_COMPRESSED, and GL_TEXTURE_COMPRESSED_IMAGE_SIZE are accepted.
 *  @param[out] params Returns the requested data.
 */
#define glGetTexLevelParameterfv(target,level,pname,params) do { glGetTexLevelParameterfv_glachwrap(target, level, pname, params); GL_AUTOCHECK_BLOCK("glGetTexLevelParameterfv", __FILE__, __LINE__); } while(0)

/**
 *  @def glGetTexLevelParameteriv
 *  @brief return texture parameter values for a specific level of detail
 *  @param[in] target Specifies the symbolic name of the target texture, one of GL_TEXTURE_1D,
 *      GL_TEXTURE_2D, GL_TEXTURE_3D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY,
 *      GL_TEXTURE_RECTANGLE, GL_TEXTURE_2D_MULTISAMPLE, GL_TEXTURE_2D_MULTISAMPLE_ARRAY,
 *      GL_TEXTURE_CUBE_MAP_POSITIVE_X, GL_TEXTURE_CUBE_MAP_NEGATIVE_X,
 *      GL_TEXTURE_CUBE_MAP_POSITIVE_Y, GL_TEXTURE_CUBE_MAP_NEGATIVE_Y,
 *      GL_TEXTURE_CUBE_MAP_POSITIVE_Z, GL_TEXTURE_CUBE_MAP_NEGATIVE_Z, GL_PROXY_TEXTURE_1D,
 *      GL_PROXY_TEXTURE_2D, GL_PROXY_TEXTURE_3D, GL_PROXY_TEXTURE_1D_ARRAY,
 *      GL_PROXY_TEXTURE_2D_ARRAY, GL_PROXY_TEXTURE_RECTANGLE, GL_PROXY_TEXTURE_2D_MULTISAMPLE,
 *      GL_PROXY_TEXTURE_2D_MULTISAMPLE_ARRAY, GL_PROXY_TEXTURE_CUBE_MAP, or GL_TEXTURE_BUFFER.
 *  @param[in] level Specifies the level-of-detail number of the desired image. Level 0 is the base
 *      image level. Level n is the nth mipmap reduction image.
 *  @param[in] pname Specifies the symbolic name of a texture parameter. GL_TEXTURE_WIDTH,
 *      GL_TEXTURE_HEIGHT, GL_TEXTURE_DEPTH, GL_TEXTURE_INTERNAL_FORMAT, GL_TEXTURE_BORDER,
 *      GL_TEXTURE_RED_SIZE, GL_TEXTURE_GREEN_SIZE, GL_TEXTURE_BLUE_SIZE, GL_TEXTURE_ALPHA_SIZE,
 *      GL_TEXTURE_DEPTH_SIZE, GL_TEXTURE_COMPRESSED, and GL_TEXTURE_COMPRESSED_IMAGE_SIZE are accepted.
 *  @param[out] params Returns the requested data.
 */
#define glGetTexLevelParameteriv(target,level,pname,params) do { glGetTexLevelParameteriv_glachwrap(target, level, pname, params); GL_AUTOCHECK_BLOCK("glGetTexLevelParameteriv", __FILE__, __LINE__); } while(0)

/**
 *  @def glIsEnabled
 *  @brief test whether a capability is enabled
 *  @param[in] cap Specifies a symbolic constant indicating a GL capability.
 */
#define glIsEnabled(cap) glIsEnabled_glachwrap(cap, __FILE__, __LINE__)

/**
 *  @def glDepthRange
 *  @brief specify mapping of depth values from normalized device coordinates to window coordinates
 *  @param[in] nearVal Specifies the mapping of the near clipping plane to window coordinates. The
 *      initial value is 0.
 *  @param[in] farVal Specifies the mapping of the far clipping plane to window coordinates. The
 *      initial value is 1.
 */
#define glDepthRange(nearVal,farVal) do { glDepthRange_glachwrap(nearVal, farVal); GL_AUTOCHECK_BLOCK("glDepthRange", __FILE__, __LINE__); } while(0)

/**
 *  @def glViewport
 *  @brief set the viewport
 *  @param[in] x Specify the lower left corner of the viewport rectangle, in pixels. The initial
 *      value is (0,0).
 *  @param[in] y Specify the lower left corner of the viewport rectangle, in pixels. The initial
 *      value is (0,0).
 *  @param[in] width Specify the width and height of the viewport. When a GL context is first
 *      attached to a window, width and height are set to the dimensions of that window.
 *  @param[in] height Specify the width and height of the viewport. When a GL context is first
 *      attached to a window, width and height are set to the dimensions of that window.
 */
#define glViewport(x,y,width,height) do { glViewport_glachwrap(x, y, width, height); GL_AUTOCHECK_BLOCK("glViewport", __FILE__, __LINE__); } while(0)

#endif // __HAVE_GL_AUTOCHECK

#endif // GL_VERSION_1_0

//                              --- ~OpenGL 1.0 ---

