//                              --- OpenGL 3.0 ---

/**
 *  @def GL_VERSION_3_0
 *  @brief if defined, OpenGL 3.0 entry points are available
 *  @note This does not necessarily mean it is also supported.
 */
#ifndef GL_VERSION_3_0
#define GL_VERSION_3_0 1

/**
 *  @def __GENERATE_GL_30__
 *  @brief if defined, code to initialize OpenGL 3.0 entry points is compiled
 */
#define __GENERATE_GL_30__

extern bool GLEH_OPENGL_3_0; /**< @brief set if OpenGL 3.0 is supported */

#define GL_COMPARE_REF_TO_TEXTURE                                   0x884E /**< @brief OpenGL 3.0 enum */
#define GL_CLIP_DISTANCE0                                           0x3000 /**< @brief OpenGL 3.0 enum */
#define GL_CLIP_DISTANCE1                                           0x3001 /**< @brief OpenGL 3.0 enum */
#define GL_CLIP_DISTANCE2                                           0x3002 /**< @brief OpenGL 3.0 enum */
#define GL_CLIP_DISTANCE3                                           0x3003 /**< @brief OpenGL 3.0 enum */
#define GL_CLIP_DISTANCE4                                           0x3004 /**< @brief OpenGL 3.0 enum */
#define GL_CLIP_DISTANCE5                                           0x3005 /**< @brief OpenGL 3.0 enum */
#define GL_CLIP_DISTANCE6                                           0x3006 /**< @brief OpenGL 3.0 enum */
#define GL_CLIP_DISTANCE7                                           0x3007 /**< @brief OpenGL 3.0 enum */
#define GL_MAX_CLIP_DISTANCES                                       0x0D32 /**< @brief OpenGL 3.0 enum */
#define GL_MAJOR_VERSION                                            0x821B /**< @brief OpenGL 3.0 enum */
#define GL_MINOR_VERSION                                            0x821C /**< @brief OpenGL 3.0 enum */
#define GL_NUM_EXTENSIONS                                           0x821D /**< @brief OpenGL 3.0 enum */
#define GL_CONTEXT_FLAGS                                            0x821E /**< @brief OpenGL 3.0 enum */
#define GL_DEPTH_BUFFER                                             0x8223 /**< @brief OpenGL 3.0 enum */
#define GL_STENCIL_BUFFER                                           0x8224 /**< @brief OpenGL 3.0 enum */
#define GL_COMPRESSED_RED                                           0x8225 /**< @brief OpenGL 3.0 enum */
#define GL_COMPRESSED_RG                                            0x8226 /**< @brief OpenGL 3.0 enum */
#define GL_CONTEXT_FLAG_FORWARD_COMPATIBLE_BIT                      0x0001 /**< @brief OpenGL 3.0 enum */
#define GL_RGBA32F                                                  0x8814 /**< @brief OpenGL 3.0 enum */
#define GL_RGB32F                                                   0x8815 /**< @brief OpenGL 3.0 enum */
#define GL_RGBA16F                                                  0x881A /**< @brief OpenGL 3.0 enum */
#define GL_RGB16F                                                   0x881B /**< @brief OpenGL 3.0 enum */
#define GL_VERTEX_ATTRIB_ARRAY_INTEGER                              0x88FD /**< @brief OpenGL 3.0 enum */
#define GL_MAX_ARRAY_TEXTURE_LAYERS                                 0x88FF /**< @brief OpenGL 3.0 enum */
#define GL_MIN_PROGRAM_TEXEL_OFFSET                                 0x8904 /**< @brief OpenGL 3.0 enum */
#define GL_MAX_PROGRAM_TEXEL_OFFSET                                 0x8905 /**< @brief OpenGL 3.0 enum */
#define GL_CLAMP_READ_COLOR                                         0x891C /**< @brief OpenGL 3.0 enum */
#define GL_FIXED_ONLY                                               0x891D /**< @brief OpenGL 3.0 enum */
//#define GL_MAX_VARYING_COMPONENTS                                   0x8B4B // deprecated (in OpenGL 3.2)
#define GL_TEXTURE_1D_ARRAY                                         0x8C18 /**< @brief OpenGL 3.0 enum */
#define GL_PROXY_TEXTURE_1D_ARRAY                                   0x8C19 /**< @brief OpenGL 3.0 enum */
#define GL_TEXTURE_2D_ARRAY                                         0x8C1A /**< @brief OpenGL 3.0 enum */
#define GL_PROXY_TEXTURE_2D_ARRAY                                   0x8C1B /**< @brief OpenGL 3.0 enum */
#define GL_TEXTURE_BINDING_1D_ARRAY                                 0x8C1C /**< @brief OpenGL 3.0 enum */
#define GL_TEXTURE_BINDING_2D_ARRAY                                 0x8C1D /**< @brief OpenGL 3.0 enum */
#define GL_R11F_G11F_B10F                                           0x8C3A /**< @brief OpenGL 3.0 enum */
#define GL_UNSIGNED_INT_10F_11F_11F_REV                             0x8C3B /**< @brief OpenGL 3.0 enum */
#define GL_RGB9_E5                                                  0x8C3D /**< @brief OpenGL 3.0 enum */
#define GL_UNSIGNED_INT_5_9_9_9_REV                                 0x8C3E /**< @brief OpenGL 3.0 enum */
#define GL_TEXTURE_SHARED_SIZE                                      0x8C3F /**< @brief OpenGL 3.0 enum */
#define GL_TRANSFORM_FEEDBACK_VARYING_MAX_LENGTH                    0x8C76 /**< @brief OpenGL 3.0 enum */
#define GL_TRANSFORM_FEEDBACK_BUFFER_MODE                           0x8C7F /**< @brief OpenGL 3.0 enum */
#define GL_MAX_TRANSFORM_FEEDBACK_SEPARATE_COMPONENTS               0x8C80 /**< @brief OpenGL 3.0 enum */
#define GL_TRANSFORM_FEEDBACK_VARYINGS                              0x8C83 /**< @brief OpenGL 3.0 enum */
#define GL_TRANSFORM_FEEDBACK_BUFFER_START                          0x8C84 /**< @brief OpenGL 3.0 enum */
#define GL_TRANSFORM_FEEDBACK_BUFFER_SIZE                           0x8C85 /**< @brief OpenGL 3.0 enum */
#define GL_PRIMITIVES_GENERATED                                     0x8C87 /**< @brief OpenGL 3.0 enum */
#define GL_TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN                    0x8C88 /**< @brief OpenGL 3.0 enum */
#define GL_RASTERIZER_DISCARD                                       0x8C89 /**< @brief OpenGL 3.0 enum */
#define GL_MAX_TRANSFORM_FEEDBACK_INTERLEAVED_COMPONENTS            0x8C8A /**< @brief OpenGL 3.0 enum */
#define GL_MAX_TRANSFORM_FEEDBACK_SEPARATE_ATTRIBS                  0x8C8B /**< @brief OpenGL 3.0 enum */
#define GL_INTERLEAVED_ATTRIBS                                      0x8C8C /**< @brief OpenGL 3.0 enum */
#define GL_SEPARATE_ATTRIBS                                         0x8C8D /**< @brief OpenGL 3.0 enum */
#define GL_TRANSFORM_FEEDBACK_BUFFER                                0x8C8E /**< @brief OpenGL 3.0 enum */
#define GL_TRANSFORM_FEEDBACK_BUFFER_BINDING                        0x8C8F /**< @brief OpenGL 3.0 enum */
#define GL_RGBA32UI                                                 0x8D70 /**< @brief OpenGL 3.0 enum */
#define GL_RGB32UI                                                  0x8D71 /**< @brief OpenGL 3.0 enum */
#define GL_RGBA16UI                                                 0x8D76 /**< @brief OpenGL 3.0 enum */
#define GL_RGB16UI                                                  0x8D77 /**< @brief OpenGL 3.0 enum */
#define GL_RGBA8UI                                                  0x8D7C /**< @brief OpenGL 3.0 enum */
#define GL_RGB8UI                                                   0x8D7D /**< @brief OpenGL 3.0 enum */
#define GL_RGBA32I                                                  0x8D82 /**< @brief OpenGL 3.0 enum */
#define GL_RGB32I                                                   0x8D83 /**< @brief OpenGL 3.0 enum */
#define GL_RGBA16I                                                  0x8D88 /**< @brief OpenGL 3.0 enum */
#define GL_RGB16I                                                   0x8D89 /**< @brief OpenGL 3.0 enum */
#define GL_RGBA8I                                                   0x8D8E /**< @brief OpenGL 3.0 enum */
#define GL_RGB8I                                                    0x8D8F /**< @brief OpenGL 3.0 enum */
#define GL_RED_INTEGER                                              0x8D94 /**< @brief OpenGL 3.0 enum */
#define GL_GREEN_INTEGER                                            0x8D95 /**< @brief OpenGL 3.0 enum */
#define GL_BLUE_INTEGER                                             0x8D96 /**< @brief OpenGL 3.0 enum */
#define GL_RGB_INTEGER                                              0x8D98 /**< @brief OpenGL 3.0 enum */
#define GL_RGBA_INTEGER                                             0x8D99 /**< @brief OpenGL 3.0 enum */
#define GL_BGR_INTEGER                                              0x8D9A /**< @brief OpenGL 3.0 enum */
#define GL_BGRA_INTEGER                                             0x8D9B /**< @brief OpenGL 3.0 enum */
#define GL_SAMPLER_1D_ARRAY                                         0x8DC0 /**< @brief OpenGL 3.0 enum */
#define GL_SAMPLER_2D_ARRAY                                         0x8DC1 /**< @brief OpenGL 3.0 enum */
#define GL_SAMPLER_1D_ARRAY_SHADOW                                  0x8DC3 /**< @brief OpenGL 3.0 enum */
#define GL_SAMPLER_2D_ARRAY_SHADOW                                  0x8DC4 /**< @brief OpenGL 3.0 enum */
#define GL_SAMPLER_CUBE_SHADOW                                      0x8DC5 /**< @brief OpenGL 3.0 enum */
#define GL_UNSIGNED_INT_VEC2                                        0x8DC6 /**< @brief OpenGL 3.0 enum */
#define GL_UNSIGNED_INT_VEC3                                        0x8DC7 /**< @brief OpenGL 3.0 enum */
#define GL_UNSIGNED_INT_VEC4                                        0x8DC8 /**< @brief OpenGL 3.0 enum */
#define GL_INT_SAMPLER_1D                                           0x8DC9 /**< @brief OpenGL 3.0 enum */
#define GL_INT_SAMPLER_2D                                           0x8DCA /**< @brief OpenGL 3.0 enum */
#define GL_INT_SAMPLER_3D                                           0x8DCB /**< @brief OpenGL 3.0 enum */
#define GL_INT_SAMPLER_CUBE                                         0x8DCC /**< @brief OpenGL 3.0 enum */
#define GL_INT_SAMPLER_1D_ARRAY                                     0x8DCE /**< @brief OpenGL 3.0 enum */
#define GL_INT_SAMPLER_2D_ARRAY                                     0x8DCF /**< @brief OpenGL 3.0 enum */
#define GL_UNSIGNED_INT_SAMPLER_1D                                  0x8DD1 /**< @brief OpenGL 3.0 enum */
#define GL_UNSIGNED_INT_SAMPLER_2D                                  0x8DD2 /**< @brief OpenGL 3.0 enum */
#define GL_UNSIGNED_INT_SAMPLER_3D                                  0x8DD3 /**< @brief OpenGL 3.0 enum */
#define GL_UNSIGNED_INT_SAMPLER_CUBE                                0x8DD4 /**< @brief OpenGL 3.0 enum */
#define GL_UNSIGNED_INT_SAMPLER_1D_ARRAY                            0x8DD6 /**< @brief OpenGL 3.0 enum */
#define GL_UNSIGNED_INT_SAMPLER_2D_ARRAY                            0x8DD7 /**< @brief OpenGL 3.0 enum */
#define GL_QUERY_WAIT                                               0x8E13 /**< @brief OpenGL 3.0 enum */
#define GL_QUERY_NO_WAIT                                            0x8E14 /**< @brief OpenGL 3.0 enum */
#define GL_QUERY_BY_REGION_WAIT                                     0x8E15 /**< @brief OpenGL 3.0 enum */
#define GL_QUERY_BY_REGION_NO_WAIT                                  0x8E16 /**< @brief OpenGL 3.0 enum */
#define GL_BUFFER_ACCESS_FLAGS                                      0x911F /**< @brief OpenGL 3.0 enum */
#define GL_BUFFER_MAP_LENGTH                                        0x9120 /**< @brief OpenGL 3.0 enum */
#define GL_BUFFER_MAP_OFFSET                                        0x9121 /**< @brief OpenGL 3.0 enum */
/* Reuse tokens from ARB_depth_buffer_float */
/* Reuse tokens from ARB_framebuffer_object */
/* Reuse tokens from ARB_framebuffer_sRGB */
/* Reuse tokens from ARB_half_float_vertex */
/* Reuse tokens from ARB_map_buffer_range */
/* Reuse tokens from ARB_texture_compression_rgtc */
/* Reuse tokens from ARB_texture_rg */
/* Reuse tokens from ARB_vertex_array_object */

/* OpenGL 3.0 also reuses entry points from these extensions: */
/* ARB_framebuffer_object */
/* ARB_map_buffer_range */
/* ARB_vertex_array_object */

/**
 *  @brief enable and disable writing of frame buffer color components
 *  @param[in] buf For glColorMaski, specifies the index of the draw buffer whose color mask to set.
 *  @param[in] red Specify whether red, green, blue, and alpha are to be written into the frame
 *      buffer. The initial values are all GL_TRUE, indicating that the color components are written.
 *  @param[in] green Specify whether red, green, blue, and alpha are to be written into the frame
 *      buffer. The initial values are all GL_TRUE, indicating that the color components are written.
 *  @param[in] blue Specify whether red, green, blue, and alpha are to be written into the frame
 *      buffer. The initial values are all GL_TRUE, indicating that the color components are written.
 *  @param[in] alpha Specify whether red, green, blue, and alpha are to be written into the frame
 *      buffer. The initial values are all GL_TRUE, indicating that the color components are written.
 */
extern void (GLApi *GLFuncPtrName(glColorMaski))(GLuint buf, GLboolean red, GLboolean green, GLboolean blue, GLboolean alpha);

/**
 *  @brief return the value or values of a selected parameter
 *  @param[in] pname Specifies the parameter value to be returned. The symbolic constants in the
 *      list below are accepted.
 *  @param[in] index Specifies the index of the particular element being queried.
 *  @param[out] data Returns the value or values of the specified parameter.
 */
extern void (GLApi *GLFuncPtrName(glGetBooleani_v))(GLenum pname, GLuint index, GLboolean *data);

/**
 *  @brief return the value or values of a selected parameter
 *  @param[in] pname Specifies the parameter value to be returned. The symbolic constants in the
 *      list below are accepted.
 *  @param[in] index Specifies the index of the particular element being queried.
 *  @param[out] data Returns the value or values of the specified parameter.
 */
extern void (GLApi *GLFuncPtrName(glGetIntegeri_v))(GLenum pname, GLuint index, int *data);

/**
 *  @brief enable or disable server-side GL capabilities
 *  @param[in] cap Specifies a symbolic constant indicating a GL capability.
 *  @param[in] index Specifies the index of the swtich to enable.
 */
extern void (GLApi *GLFuncPtrName(glEnablei))(GLenum cap, GLuint index);

/**
 *  @brief enable or disable server-side GL capabilities
 *  @param[in] cap Specifies a symbolic constant indicating a GL capability.
 *  @param[in] index Specifies the index of the swtich to disable.
 */
extern void (GLApi *GLFuncPtrName(glDisablei))(GLenum cap, GLuint index);

/**
 *  @brief test whether a capability is enabled
 *  @param[in] cap Specifies a symbolic constant indicating a GL capability.
 *  @param[in] index Specifies the index of the capability.
 */
extern GLboolean (GLApi *GLFuncPtrName(glIsEnabledi))(GLenum cap, GLuint index);

/**
 *  @brief start transform feedback operation
 *  @param[in] primitiveMode Specify the output type of the primitives that will be recorded into
 *      the buffer objects that are bound for transform feedback.
 */
extern void (GLApi *GLFuncPtrName(glBeginTransformFeedback))(GLenum primitiveMode);

/**
 *  @brief start transform feedback operation
 */
extern void (GLApi *GLFuncPtrName(glEndTransformFeedback))();

/**
 *  @brief bind a range within a buffer object to an indexed buffer target
 *  @param[in] target Specify the target of the bind operation. target must be either
 *      GL_TRANSFORM_FEEDBACK_BUFFER or GL_UNIFORM_BUFFER.
 *  @param[in] index Specify the index of the binding point within the array specified by target.
 *  @param[in] buffer The name of a buffer object to bind to the specified binding point.
 *  @param[in] offset The starting offset in basic machine units into the buffer object buffer.
 *  @param[in] size The amount of data in machine units that can be read from the buffet object
 *      while used as an indexed target.
 */
extern void (GLApi *GLFuncPtrName(glBindBufferRange))(GLenum target, GLuint index, GLuint buffer, GLintptr offset, GLsizeiptr size);

/**
 *  @brief bind a buffer object to an indexed buffer target
 *  @param[in] target Specify the target of the bind operation. target must be either
 *      GL_TRANSFORM_FEEDBACK_BUFFER or GL_UNIFORM_BUFFER.
 *  @param[in] index Specify the index of the binding point within the array specified by target.
 *  @param[in] buffer The name of a buffer object to bind to the specified binding point.
 */
extern void (GLApi *GLFuncPtrName(glBindBufferBase))(GLenum target, GLuint index, GLuint buffer);

/**
 *  @brief specify values to record in transform feedback buffers
 *  @param[in] program The name of the target program object.
 *  @param[in] count The number of varying variables used for transform feedback.
 *  @param[in] varyings An array of count zero-terminated strings specifying the names of the
 *      varying variables to use for transform feedback.
 *  @param[in] bufferMode Identifies the mode used to capture the varying variables when transform
 *      feedback is active. bufferMode must be GL_INTERLEAVED_ATTRIBS or GL_SEPARATE_ATTRIBS.
 */
extern void (GLApi *GLFuncPtrName(glTransformFeedbackVaryings))(GLuint program, GLsizei count, const GLchar **varyings, GLenum bufferMode);

/**
 *  @brief retrieve information about varying variables selected for transform feedback
 *  @param[in] program The name of the target program object.
 *  @param[in] index The index of the varying variable whose information to retrieve.
 *  @param[in] bufSize The maximum number of characters, including the null terminator, that may be
 *      written into name.
 *  @param[out] length The address of a variable which will receive the number of characters written
 *      into name, excluding the null-terminator. If length is NULL no length is returned.
 *  @param[out] size The address of a variable that will receive the size of the varying.
 *  @param[out] type The address of a variable that will recieve the type of the varying.
 *  @param[out] name The address of a buffer into which will be written the name of the varying.
 */
extern void (GLApi *GLFuncPtrName(glGetTransformFeedbackVarying))(GLuint program, GLuint index, GLsizei bufSize, GLsizei *length, GLsizei *size, GLenum *type, GLchar *name);

/**
 *  @brief specify whether data read via
 *  @param[in] target Target for color clamping. target must be GL_CLAMP_READ_COLOR.
 *  @param[in] clamp Specifies whether to apply color clamping. clamp must be GL_TRUE or GL_FALSE.
 */
extern void (GLApi *GLFuncPtrName(glClampColor))(GLenum target, GLenum clamp);

/**
 *  @brief start conditional rendering
 *  @param[in] id Specifies the name of an occlusion query object whose results are used to
 *      determine if the rendering commands are discarded.
 *  @param[in] mode Specifies how glBeginConditionalRender interprets the results of the occlusion query.
 */
extern void (GLApi *GLFuncPtrName(glBeginConditionalRender))(GLuint id, GLenum mode);

/**
 *  @brief start conditional rendering
 */
extern void (GLApi *GLFuncPtrName(glEndConditionalRender))();

/**
 *  @brief define an array of generic vertex attribute data
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] size Specifies the number of components per generic vertex attribute. Must be 1, 2,
 *      3, 4. Additionally, the symbolic constant GL_BGRA is accepted by glVertexAttribPointer. The
 *      initial value is 4.
 *  @param[in] type Specifies the data type of each component in the array. The symbolic constants
 *      GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, and GL_UNSIGNED_INT are
 *      accepted by both functions. Additionally GL_HALF_FLOAT, GL_FLOAT, GL_DOUBLE, GL_FIXED,
 *      GL_INT_2_10_10_10_REV, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted by
 *      glVertexAttribPointer. The initial value is GL_FLOAT.
 *  @param[in] stride Specifies the byte offset between consecutive generic vertex attributes. If
 *      stride is 0, the generic vertex attributes are understood to be tightly packed in the array.
 *      The initial value is 0.
 *  @param[in] pointer Specifies a offset of the first component of the first generic vertex
 *      attribute in the array in the data store of the buffer currently bound to the
 *      GL_ARRAY_BUFFER target. The initial value is 0.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttribIPointer))(GLuint index, int size, GLenum type, GLsizei stride, const void *pointer);

/**
 *  @brief Return a generic vertex attribute parameter
 *  @param[in] index Specifies the generic vertex attribute parameter to be queried.
 *  @param[in] pname Specifies the symbolic name of the vertex attribute parameter to be queried.
 *      Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED,
 *      GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE,
 *      GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER,
 *      GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
 *  @param[out] params Returns the requested data.
 */
extern void (GLApi *GLFuncPtrName(glGetVertexAttribIiv))(GLuint index, GLenum pname, int *params);

/**
 *  @brief Return a generic vertex attribute parameter
 *  @param[in] index Specifies the generic vertex attribute parameter to be queried.
 *  @param[in] pname Specifies the symbolic name of the vertex attribute parameter to be queried.
 *      Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED,
 *      GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE,
 *      GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER,
 *      GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
 *  @param[out] params Returns the requested data.
 */
extern void (GLApi *GLFuncPtrName(glGetVertexAttribIuiv))(GLuint index, GLenum pname, GLuint *params);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttribI1i))(GLuint index, int v0);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v1 Specifies the new values to be used for the specified vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttribI2i))(GLuint index, int v0, int v1);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v1 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v2 Specifies the new values to be used for the specified vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttribI3i))(GLuint index, int v0, int v1, int v2);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v1 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v2 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v3 Specifies the new values to be used for the specified vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttribI4i))(GLuint index, int v0, int v1, int v2, int v3);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttribI1ui))(GLuint index, GLuint v0);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v1 Specifies the new values to be used for the specified vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttribI2ui))(GLuint index, GLuint v0, GLuint v1);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v1 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v2 Specifies the new values to be used for the specified vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttribI3ui))(GLuint index, GLuint v0, GLuint v1, GLuint v2);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v1 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v2 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v3 Specifies the new values to be used for the specified vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttribI4ui))(GLuint index, GLuint v0, GLuint v1, GLuint v2, GLuint v3);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttribI1iv))(GLuint index, const int *v);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttribI2iv))(GLuint index, const int *v);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttribI3iv))(GLuint index, const int *v);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttribI4iv))(GLuint index, const int *v);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttribI1uiv))(GLuint index, const GLuint *v);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttribI2uiv))(GLuint index, const GLuint *v);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttribI3uiv))(GLuint index, const GLuint *v);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttribI4uiv))(GLuint index, const GLuint *v);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttribI4bv))(GLuint index, const GLbyte *v);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttribI4sv))(GLuint index, const short *v);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttribI4ubv))(GLuint index, const GLubyte *v);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttribI4usv))(GLuint index, const GLushort *v);

/**
 *  @brief Returns the value of a uniform variable
 *  @param[in] program Specifies the program object to be queried.
 *  @param[in] location Specifies the location of the uniform variable to be queried.
 *  @param[out] params Returns the value of the specified uniform variable.
 */
extern void (GLApi *GLFuncPtrName(glGetUniformuiv))(GLuint program, int location, GLuint *params);

/**
 *  @brief bind a user-defined varying out variable to a fragment shader color number
 *  @param[in] program The name of the program containing varying out variable whose binding to modify
 *  @param[in] colorNumber The color number to bind the user-defined varying out variable to
 *  @param[in] name The name of the user-defined varying out variable whose binding to modify
 */
extern void (GLApi *GLFuncPtrName(glBindFragDataLocation))(GLuint program, GLuint colorNumber, const GLchar *name);

/**
 *  @brief query the bindings of color numbers to user-defined varying out variables
 *  @param[in] program The name of the program containing varying out variable whose binding to query
 *  @param[in] name The name of the user-defined varying out variable whose binding to query
 */
extern int (GLApi *GLFuncPtrName(glGetFragDataLocation))(GLuint program, const GLchar *name);

/**
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform variable to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified uniform variable.
 */
extern void (GLApi *GLFuncPtrName(glUniform1ui))(int location, GLuint v0);

/**
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform variable to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified uniform variable.
 *  @param[in] v1 Specifies the new values to be used for the specified uniform variable.
 */
extern void (GLApi *GLFuncPtrName(glUniform2ui))(int location, GLuint v0, GLuint v1);

/**
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform variable to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified uniform variable.
 *  @param[in] v1 Specifies the new values to be used for the specified uniform variable.
 *  @param[in] v2 Specifies the new values to be used for the specified uniform variable.
 */
extern void (GLApi *GLFuncPtrName(glUniform3ui))(int location, GLuint v0, GLuint v1, GLuint v2);

/**
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform variable to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified uniform variable.
 *  @param[in] v1 Specifies the new values to be used for the specified uniform variable.
 *  @param[in] v2 Specifies the new values to be used for the specified uniform variable.
 *  @param[in] v3 Specifies the new values to be used for the specified uniform variable.
 */
extern void (GLApi *GLFuncPtrName(glUniform4ui))(int location, GLuint v0, GLuint v1, GLuint v2, GLuint v3);

/**
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform value to be modified.
 *  @param[in] count Specifies the number of elements that are to be modified. This should be 1 if
 *      the targeted uniform variable is not an array, and 1 or more if it is an array.
 *  @param[in] value Specifies a pointer to an array of count values that will be used to update the
 *      specified uniform variable.
 */
extern void (GLApi *GLFuncPtrName(glUniform1uiv))(int location, GLsizei count, const GLuint *value);

/**
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform value to be modified.
 *  @param[in] count Specifies the number of elements that are to be modified. This should be 1 if
 *      the targeted uniform variable is not an array, and 1 or more if it is an array.
 *  @param[in] value Specifies a pointer to an array of count values that will be used to update the
 *      specified uniform variable.
 */
extern void (GLApi *GLFuncPtrName(glUniform2uiv))(int location, GLsizei count, const GLuint *value);

/**
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform value to be modified.
 *  @param[in] count Specifies the number of elements that are to be modified. This should be 1 if
 *      the targeted uniform variable is not an array, and 1 or more if it is an array.
 *  @param[in] value Specifies a pointer to an array of count values that will be used to update the
 *      specified uniform variable.
 */
extern void (GLApi *GLFuncPtrName(glUniform3uiv))(int location, GLsizei count, const GLuint *value);

/**
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform value to be modified.
 *  @param[in] count Specifies the number of elements that are to be modified. This should be 1 if
 *      the targeted uniform variable is not an array, and 1 or more if it is an array.
 *  @param[in] value Specifies a pointer to an array of count values that will be used to update the
 *      specified uniform variable.
 */
extern void (GLApi *GLFuncPtrName(glUniform4uiv))(int location, GLsizei count, const GLuint *value);

/**
 *  @brief set texture parameters
 *  @param[in] target Specifies the target texture, which must be either GL_TEXTURE_1D,
 *      GL_TEXTURE_2D, GL_TEXTURE_3D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY,
 *      GL_TEXTURE_RECTANGLE, or GL_TEXTURE_CUBE_MAP.
 *  @param[in] pname Specifies the symbolic name of a texture parameter. pname can be one of the
 *      following: GL_TEXTURE_BASE_LEVEL, GL_TEXTURE_BORDER_COLOR, GL_TEXTURE_COMPARE_FUNC,
 *      GL_TEXTURE_COMPARE_MODE, GL_TEXTURE_LOD_BIAS, GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MAG_FILTER,
 *      GL_TEXTURE_MIN_LOD, GL_TEXTURE_MAX_LOD, GL_TEXTURE_MAX_LEVEL, GL_TEXTURE_SWIZZLE_R,
 *      GL_TEXTURE_SWIZZLE_G, GL_TEXTURE_SWIZZLE_B, GL_TEXTURE_SWIZZLE_A, GL_TEXTURE_SWIZZLE_RGBA,
 *      GL_TEXTURE_WRAP_S, GL_TEXTURE_WRAP_T, or GL_TEXTURE_WRAP_R.
 *  @param[in] params Specifies a pointer to an array where the value or values of pname are stored.
 */
extern void (GLApi *GLFuncPtrName(glTexParameterIiv))(GLenum target, GLenum pname, const int *params);

/**
 *  @brief set texture parameters
 *  @param[in] target Specifies the target texture, which must be either GL_TEXTURE_1D,
 *      GL_TEXTURE_2D, GL_TEXTURE_3D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY,
 *      GL_TEXTURE_RECTANGLE, or GL_TEXTURE_CUBE_MAP.
 *  @param[in] pname Specifies the symbolic name of a texture parameter. pname can be one of the
 *      following: GL_TEXTURE_BASE_LEVEL, GL_TEXTURE_BORDER_COLOR, GL_TEXTURE_COMPARE_FUNC,
 *      GL_TEXTURE_COMPARE_MODE, GL_TEXTURE_LOD_BIAS, GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MAG_FILTER,
 *      GL_TEXTURE_MIN_LOD, GL_TEXTURE_MAX_LOD, GL_TEXTURE_MAX_LEVEL, GL_TEXTURE_SWIZZLE_R,
 *      GL_TEXTURE_SWIZZLE_G, GL_TEXTURE_SWIZZLE_B, GL_TEXTURE_SWIZZLE_A, GL_TEXTURE_SWIZZLE_RGBA,
 *      GL_TEXTURE_WRAP_S, GL_TEXTURE_WRAP_T, or GL_TEXTURE_WRAP_R.
 *  @param[in] params Specifies a pointer to an array where the value or values of pname are stored.
 */
extern void (GLApi *GLFuncPtrName(glTexParameterIuiv))(GLenum target, GLenum pname, const GLuint *params);

/**
 *  @brief return texture parameter values
 *  @param[in] target Specifies the symbolic name of the target texture. GL_TEXTURE_1D,
 *      GL_TEXTURE_2D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY, GL_TEXTURE_3D,
 *      GL_TEXTURE_RECTANGLE, and GL_TEXTURE_CUBE_MAP are accepted.
 *  @param[in] pname Specifies the symbolic name of a texture parameter. GL_TEXTURE_BASE_LEVEL,
 *      GL_TEXTURE_BORDER_COLOR, GL_TEXTURE_COMPARE_MODE, GL_TEXTURE_COMPARE_FUNC,
 *      GL_TEXTURE_LOD_BIAS, GL_TEXTURE_MAG_FILTER, GL_TEXTURE_MAX_LEVEL, GL_TEXTURE_MAX_LOD,
 *      GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MIN_LOD, GL_TEXTURE_SWIZZLE_R, GL_TEXTURE_SWIZZLE_G,
 *      GL_TEXTURE_SWIZZLE_B, GL_TEXTURE_SWIZZLE_A, GL_TEXTURE_SWIZZLE_RGBA, GL_TEXTURE_WRAP_S,
 *      GL_TEXTURE_WRAP_T, and GL_TEXTURE_WRAP_R are accepted.
 *  @param[out] params Returns the texture parameters.
 */
extern void (GLApi *GLFuncPtrName(glGetTexParameterIiv))(GLenum target, GLenum pname, int *params);

/**
 *  @brief return texture parameter values
 *  @param[in] target Specifies the symbolic name of the target texture. GL_TEXTURE_1D,
 *      GL_TEXTURE_2D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY, GL_TEXTURE_3D,
 *      GL_TEXTURE_RECTANGLE, and GL_TEXTURE_CUBE_MAP are accepted.
 *  @param[in] pname Specifies the symbolic name of a texture parameter. GL_TEXTURE_BASE_LEVEL,
 *      GL_TEXTURE_BORDER_COLOR, GL_TEXTURE_COMPARE_MODE, GL_TEXTURE_COMPARE_FUNC,
 *      GL_TEXTURE_LOD_BIAS, GL_TEXTURE_MAG_FILTER, GL_TEXTURE_MAX_LEVEL, GL_TEXTURE_MAX_LOD,
 *      GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MIN_LOD, GL_TEXTURE_SWIZZLE_R, GL_TEXTURE_SWIZZLE_G,
 *      GL_TEXTURE_SWIZZLE_B, GL_TEXTURE_SWIZZLE_A, GL_TEXTURE_SWIZZLE_RGBA, GL_TEXTURE_WRAP_S,
 *      GL_TEXTURE_WRAP_T, and GL_TEXTURE_WRAP_R are accepted.
 *  @param[out] params Returns the texture parameters.
 */
extern void (GLApi *GLFuncPtrName(glGetTexParameterIuiv))(GLenum target, GLenum pname, GLuint *params);

/**
 *  @brief clear individual buffers of the currently bound draw framebuffer
 *  @param[in] buffer Specify the buffer to clear.
 *  @param[in] drawBuffer Specify a particular draw buffer to clear.
 *  @param[in] value For color buffers, a pointer to a four-element vector specifying R, G, B and A
 *      values to clear the buffer to. For depth buffers, a pointer to a single depth value to clear
 *      the buffer to. For stencil buffers, a pointer to a single stencil value to clear the buffer to.
 */
extern void (GLApi *GLFuncPtrName(glClearBufferiv))(GLenum buffer, int drawBuffer, const int *value);

/**
 *  @brief clear individual buffers of the currently bound draw framebuffer
 *  @param[in] buffer Specify the buffer to clear.
 *  @param[in] drawBuffer Specify a particular draw buffer to clear.
 *  @param[in] value For color buffers, a pointer to a four-element vector specifying R, G, B and A
 *      values to clear the buffer to. For depth buffers, a pointer to a single depth value to clear
 *      the buffer to. For stencil buffers, a pointer to a single stencil value to clear the buffer to.
 */
extern void (GLApi *GLFuncPtrName(glClearBufferuiv))(GLenum buffer, int drawBuffer, const GLuint *value);

/**
 *  @brief clear individual buffers of the currently bound draw framebuffer
 *  @param[in] buffer Specify the buffer to clear.
 *  @param[in] drawBuffer Specify a particular draw buffer to clear.
 *  @param[in] value For color buffers, a pointer to a four-element vector specifying R, G, B and A
 *      values to clear the buffer to. For depth buffers, a pointer to a single depth value to clear
 *      the buffer to. For stencil buffers, a pointer to a single stencil value to clear the buffer to.
 */
extern void (GLApi *GLFuncPtrName(glClearBufferfv))(GLenum buffer, int drawBuffer, const float *value);

/**
 *  @brief clear individual buffers of the currently bound draw framebuffer
 *  @param[in] buffer Specify the buffer to clear.
 *  @param[in] drawBuffer Specify a particular draw buffer to clear.
 *  @param[in] depth The value to clear a depth render buffer to.
 *  @param[in] stencil The value to clear a stencil render buffer to.
 */
extern void (GLApi *GLFuncPtrName(glClearBufferfi))(GLenum buffer, int drawBuffer, float depth, int stencil);

/**
 *  @brief return a string describing the current GL connection
 *  @param[in] name Specifies a symbolic constant, one of GL_VENDOR, GL_RENDERER, GL_VERSION, or
 *      GL_SHADING_LANGUAGE_VERSION. Additionally, glGetStringi accepts the GL_EXTENSIONS token.
 *  @param[in] index For glGetStringi, specifies the index of the string to return.
 */
extern const GLubyte* (GLApi *GLFuncPtrName(glGetStringi))(GLenum name, GLuint index);

inline GLboolean glIsEnabledi_glachwrap(GLenum cap, GLuint index, const char *p_s_filename, int n_line) { GLboolean result = GLFuncPtrName(glIsEnabledi)(cap,index); GL_AUTOCHECK_BLOCK("glIsEnabledi", p_s_filename, n_line); return result; }
inline int glGetFragDataLocation_glachwrap(GLuint program, const GLchar *name, const char *p_s_filename, int n_line) { int result = GLFuncPtrName(glGetFragDataLocation)(program,name); GL_AUTOCHECK_BLOCK("glGetFragDataLocation", p_s_filename, n_line); return result; }
inline const GLubyte *glGetStringi_glachwrap(GLenum name, GLuint index, const char *p_s_filename, int n_line) { const GLubyte *result = GLFuncPtrName(glGetStringi)(name,index); GL_AUTOCHECK_BLOCK("glGetStringi", p_s_filename, n_line); return result; }

/**
 *  @def glColorMaski
 *  @brief enable and disable writing of frame buffer color components
 *  @param[in] buf For glColorMaski, specifies the index of the draw buffer whose color mask to set.
 *  @param[in] red Specify whether red, green, blue, and alpha are to be written into the frame
 *      buffer. The initial values are all GL_TRUE, indicating that the color components are written.
 *  @param[in] green Specify whether red, green, blue, and alpha are to be written into the frame
 *      buffer. The initial values are all GL_TRUE, indicating that the color components are written.
 *  @param[in] blue Specify whether red, green, blue, and alpha are to be written into the frame
 *      buffer. The initial values are all GL_TRUE, indicating that the color components are written.
 *  @param[in] alpha Specify whether red, green, blue, and alpha are to be written into the frame
 *      buffer. The initial values are all GL_TRUE, indicating that the color components are written.
 */
#define glColorMaski(buf,red,green,blue,alpha) do { GLFuncPtrName(glColorMaski)(buf, red, green, blue, alpha); GL_AUTOCHECK_BLOCK("glColorMaski", __FILE__, __LINE__); } while(0)

/**
 *  @def glGetBooleani_v
 *  @brief return the value or values of a selected parameter
 *  @param[in] pname Specifies the parameter value to be returned. The symbolic constants in the
 *      list below are accepted.
 *  @param[in] index Specifies the index of the particular element being queried.
 *  @param[out] data Returns the value or values of the specified parameter.
 */
#define glGetBooleani_v(pname,index,data) do { GLFuncPtrName(glGetBooleani_v)(pname, index, data); GL_AUTOCHECK_BLOCK("glGetBooleani_v", __FILE__, __LINE__); } while(0)

/**
 *  @def glGetIntegeri_v
 *  @brief return the value or values of a selected parameter
 *  @param[in] pname Specifies the parameter value to be returned. The symbolic constants in the
 *      list below are accepted.
 *  @param[in] index Specifies the index of the particular element being queried.
 *  @param[out] data Returns the value or values of the specified parameter.
 */
#define glGetIntegeri_v(pname,index,data) do { GLFuncPtrName(glGetIntegeri_v)(pname, index, data); GL_AUTOCHECK_BLOCK("glGetIntegeri_v", __FILE__, __LINE__); } while(0)

/**
 *  @def glEnablei
 *  @brief enable or disable server-side GL capabilities
 *  @param[in] cap Specifies a symbolic constant indicating a GL capability.
 *  @param[in] index Specifies the index of the swtich to enable.
 */
#define glEnablei(cap,index) do { GLFuncPtrName(glEnablei)(cap, index); GL_AUTOCHECK_BLOCK("glEnablei", __FILE__, __LINE__); } while(0)

/**
 *  @def glDisablei
 *  @brief enable or disable server-side GL capabilities
 *  @param[in] cap Specifies a symbolic constant indicating a GL capability.
 *  @param[in] index Specifies the index of the swtich to disable.
 */
#define glDisablei(cap,index) do { GLFuncPtrName(glDisablei)(cap, index); GL_AUTOCHECK_BLOCK("glDisablei", __FILE__, __LINE__); } while(0)

/**
 *  @def glIsEnabledi
 *  @brief test whether a capability is enabled
 *  @param[in] cap Specifies a symbolic constant indicating a GL capability.
 *  @param[in] index Specifies the index of the capability.
 */
#define glIsEnabledi(cap,index) GLAutoCheckFuncPtrName(glIsEnabledi)(cap, index GLAutoCheckExtraParams)

/**
 *  @def glBeginTransformFeedback
 *  @brief start transform feedback operation
 *  @param[in] primitiveMode Specify the output type of the primitives that will be recorded into
 *      the buffer objects that are bound for transform feedback.
 */
#define glBeginTransformFeedback(primitiveMode) do { GLFuncPtrName(glBeginTransformFeedback)(primitiveMode); GL_AUTOCHECK_BLOCK("glBeginTransformFeedback", __FILE__, __LINE__); } while(0)

/**
 *  @def glEndTransformFeedback
 *  @brief start transform feedback operation
 */
#define glEndTransformFeedback() do { GLFuncPtrName(glEndTransformFeedback)(); GL_AUTOCHECK_BLOCK("glEndTransformFeedback", __FILE__, __LINE__); } while(0)

/**
 *  @def glBindBufferRange
 *  @brief bind a range within a buffer object to an indexed buffer target
 *  @param[in] target Specify the target of the bind operation. target must be either
 *      GL_TRANSFORM_FEEDBACK_BUFFER or GL_UNIFORM_BUFFER.
 *  @param[in] index Specify the index of the binding point within the array specified by target.
 *  @param[in] buffer The name of a buffer object to bind to the specified binding point.
 *  @param[in] offset The starting offset in basic machine units into the buffer object buffer.
 *  @param[in] size The amount of data in machine units that can be read from the buffet object
 *      while used as an indexed target.
 */
#define glBindBufferRange(target,index,buffer,offset,size) do { GLFuncPtrName(glBindBufferRange)(target, index, buffer, offset, size); GL_AUTOCHECK_BLOCK("glBindBufferRange", __FILE__, __LINE__); } while(0)

/**
 *  @def glBindBufferBase
 *  @brief bind a buffer object to an indexed buffer target
 *  @param[in] target Specify the target of the bind operation. target must be either
 *      GL_TRANSFORM_FEEDBACK_BUFFER or GL_UNIFORM_BUFFER.
 *  @param[in] index Specify the index of the binding point within the array specified by target.
 *  @param[in] buffer The name of a buffer object to bind to the specified binding point.
 */
#define glBindBufferBase(target,index,buffer) do { GLFuncPtrName(glBindBufferBase)(target, index, buffer); GL_AUTOCHECK_BLOCK("glBindBufferBase", __FILE__, __LINE__); } while(0)

/**
 *  @def glTransformFeedbackVaryings
 *  @brief specify values to record in transform feedback buffers
 *  @param[in] program The name of the target program object.
 *  @param[in] count The number of varying variables used for transform feedback.
 *  @param[in] varyings An array of count zero-terminated strings specifying the names of the
 *      varying variables to use for transform feedback.
 *  @param[in] bufferMode Identifies the mode used to capture the varying variables when transform
 *      feedback is active. bufferMode must be GL_INTERLEAVED_ATTRIBS or GL_SEPARATE_ATTRIBS.
 */
#define glTransformFeedbackVaryings(program,count,varyings,bufferMode) do { GLFuncPtrName(glTransformFeedbackVaryings)(program, count, varyings, bufferMode); GL_AUTOCHECK_BLOCK("glTransformFeedbackVaryings", __FILE__, __LINE__); } while(0)

/**
 *  @def glGetTransformFeedbackVarying
 *  @brief retrieve information about varying variables selected for transform feedback
 *  @param[in] program The name of the target program object.
 *  @param[in] index The index of the varying variable whose information to retrieve.
 *  @param[in] bufSize The maximum number of characters, including the null terminator, that may be
 *      written into name.
 *  @param[out] length The address of a variable which will receive the number of characters written
 *      into name, excluding the null-terminator. If length is NULL no length is returned.
 *  @param[out] size The address of a variable that will receive the size of the varying.
 *  @param[out] type The address of a variable that will recieve the type of the varying.
 *  @param[out] name The address of a buffer into which will be written the name of the varying.
 */
#define glGetTransformFeedbackVarying(program,index,bufSize,length,size,type,name) do { GLFuncPtrName(glGetTransformFeedbackVarying)(program, index, bufSize, length, size, type, name); GL_AUTOCHECK_BLOCK("glGetTransformFeedbackVarying", __FILE__, __LINE__); } while(0)

/**
 *  @def glClampColor
 *  @brief specify whether data read via
 *  @param[in] target Target for color clamping. target must be GL_CLAMP_READ_COLOR.
 *  @param[in] clamp Specifies whether to apply color clamping. clamp must be GL_TRUE or GL_FALSE.
 */
#define glClampColor(target,clamp) do { GLFuncPtrName(glClampColor)(target, clamp); GL_AUTOCHECK_BLOCK("glClampColor", __FILE__, __LINE__); } while(0)

/**
 *  @def glBeginConditionalRender
 *  @brief start conditional rendering
 *  @param[in] id Specifies the name of an occlusion query object whose results are used to
 *      determine if the rendering commands are discarded.
 *  @param[in] mode Specifies how glBeginConditionalRender interprets the results of the occlusion query.
 */
#define glBeginConditionalRender(id,mode) do { GLFuncPtrName(glBeginConditionalRender)(id, mode); GL_AUTOCHECK_BLOCK("glBeginConditionalRender", __FILE__, __LINE__); } while(0)

/**
 *  @def glEndConditionalRender
 *  @brief start conditional rendering
 */
#define glEndConditionalRender() do { GLFuncPtrName(glEndConditionalRender)(); GL_AUTOCHECK_BLOCK("glEndConditionalRender", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttribIPointer
 *  @brief define an array of generic vertex attribute data
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] size Specifies the number of components per generic vertex attribute. Must be 1, 2,
 *      3, 4. Additionally, the symbolic constant GL_BGRA is accepted by glVertexAttribPointer. The
 *      initial value is 4.
 *  @param[in] type Specifies the data type of each component in the array. The symbolic constants
 *      GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, and GL_UNSIGNED_INT are
 *      accepted by both functions. Additionally GL_HALF_FLOAT, GL_FLOAT, GL_DOUBLE, GL_FIXED,
 *      GL_INT_2_10_10_10_REV, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted by
 *      glVertexAttribPointer. The initial value is GL_FLOAT.
 *  @param[in] stride Specifies the byte offset between consecutive generic vertex attributes. If
 *      stride is 0, the generic vertex attributes are understood to be tightly packed in the array.
 *      The initial value is 0.
 *  @param[in] pointer Specifies a offset of the first component of the first generic vertex
 *      attribute in the array in the data store of the buffer currently bound to the
 *      GL_ARRAY_BUFFER target. The initial value is 0.
 */
#define glVertexAttribIPointer(index,size,type,stride,pointer) do { GLFuncPtrName(glVertexAttribIPointer)(index, size, type, stride, pointer); GL_AUTOCHECK_BLOCK("glVertexAttribIPointer", __FILE__, __LINE__); } while(0)

/**
 *  @def glGetVertexAttribIiv
 *  @brief Return a generic vertex attribute parameter
 *  @param[in] index Specifies the generic vertex attribute parameter to be queried.
 *  @param[in] pname Specifies the symbolic name of the vertex attribute parameter to be queried.
 *      Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED,
 *      GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE,
 *      GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER,
 *      GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
 *  @param[out] params Returns the requested data.
 */
#define glGetVertexAttribIiv(index,pname,params) do { GLFuncPtrName(glGetVertexAttribIiv)(index, pname, params); GL_AUTOCHECK_BLOCK("glGetVertexAttribIiv", __FILE__, __LINE__); } while(0)

/**
 *  @def glGetVertexAttribIuiv
 *  @brief Return a generic vertex attribute parameter
 *  @param[in] index Specifies the generic vertex attribute parameter to be queried.
 *  @param[in] pname Specifies the symbolic name of the vertex attribute parameter to be queried.
 *      Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED,
 *      GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE,
 *      GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER,
 *      GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
 *  @param[out] params Returns the requested data.
 */
#define glGetVertexAttribIuiv(index,pname,params) do { GLFuncPtrName(glGetVertexAttribIuiv)(index, pname, params); GL_AUTOCHECK_BLOCK("glGetVertexAttribIuiv", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttribI1i
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified vertex attribute.
 */
#define glVertexAttribI1i(index,v0) do { GLFuncPtrName(glVertexAttribI1i)(index, v0); GL_AUTOCHECK_BLOCK("glVertexAttribI1i", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttribI2i
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v1 Specifies the new values to be used for the specified vertex attribute.
 */
#define glVertexAttribI2i(index,v0,v1) do { GLFuncPtrName(glVertexAttribI2i)(index, v0, v1); GL_AUTOCHECK_BLOCK("glVertexAttribI2i", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttribI3i
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v1 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v2 Specifies the new values to be used for the specified vertex attribute.
 */
#define glVertexAttribI3i(index,v0,v1,v2) do { GLFuncPtrName(glVertexAttribI3i)(index, v0, v1, v2); GL_AUTOCHECK_BLOCK("glVertexAttribI3i", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttribI4i
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v1 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v2 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v3 Specifies the new values to be used for the specified vertex attribute.
 */
#define glVertexAttribI4i(index,v0,v1,v2,v3) do { GLFuncPtrName(glVertexAttribI4i)(index, v0, v1, v2, v3); GL_AUTOCHECK_BLOCK("glVertexAttribI4i", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttribI1ui
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified vertex attribute.
 */
#define glVertexAttribI1ui(index,v0) do { GLFuncPtrName(glVertexAttribI1ui)(index, v0); GL_AUTOCHECK_BLOCK("glVertexAttribI1ui", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttribI2ui
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v1 Specifies the new values to be used for the specified vertex attribute.
 */
#define glVertexAttribI2ui(index,v0,v1) do { GLFuncPtrName(glVertexAttribI2ui)(index, v0, v1); GL_AUTOCHECK_BLOCK("glVertexAttribI2ui", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttribI3ui
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v1 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v2 Specifies the new values to be used for the specified vertex attribute.
 */
#define glVertexAttribI3ui(index,v0,v1,v2) do { GLFuncPtrName(glVertexAttribI3ui)(index, v0, v1, v2); GL_AUTOCHECK_BLOCK("glVertexAttribI3ui", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttribI4ui
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v1 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v2 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v3 Specifies the new values to be used for the specified vertex attribute.
 */
#define glVertexAttribI4ui(index,v0,v1,v2,v3) do { GLFuncPtrName(glVertexAttribI4ui)(index, v0, v1, v2, v3); GL_AUTOCHECK_BLOCK("glVertexAttribI4ui", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttribI1iv
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
#define glVertexAttribI1iv(index,v) do { GLFuncPtrName(glVertexAttribI1iv)(index, v); GL_AUTOCHECK_BLOCK("glVertexAttribI1iv", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttribI2iv
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
#define glVertexAttribI2iv(index,v) do { GLFuncPtrName(glVertexAttribI2iv)(index, v); GL_AUTOCHECK_BLOCK("glVertexAttribI2iv", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttribI3iv
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
#define glVertexAttribI3iv(index,v) do { GLFuncPtrName(glVertexAttribI3iv)(index, v); GL_AUTOCHECK_BLOCK("glVertexAttribI3iv", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttribI4iv
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
#define glVertexAttribI4iv(index,v) do { GLFuncPtrName(glVertexAttribI4iv)(index, v); GL_AUTOCHECK_BLOCK("glVertexAttribI4iv", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttribI1uiv
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
#define glVertexAttribI1uiv(index,v) do { GLFuncPtrName(glVertexAttribI1uiv)(index, v); GL_AUTOCHECK_BLOCK("glVertexAttribI1uiv", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttribI2uiv
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
#define glVertexAttribI2uiv(index,v) do { GLFuncPtrName(glVertexAttribI2uiv)(index, v); GL_AUTOCHECK_BLOCK("glVertexAttribI2uiv", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttribI3uiv
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
#define glVertexAttribI3uiv(index,v) do { GLFuncPtrName(glVertexAttribI3uiv)(index, v); GL_AUTOCHECK_BLOCK("glVertexAttribI3uiv", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttribI4uiv
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
#define glVertexAttribI4uiv(index,v) do { GLFuncPtrName(glVertexAttribI4uiv)(index, v); GL_AUTOCHECK_BLOCK("glVertexAttribI4uiv", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttribI4bv
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
#define glVertexAttribI4bv(index,v) do { GLFuncPtrName(glVertexAttribI4bv)(index, v); GL_AUTOCHECK_BLOCK("glVertexAttribI4bv", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttribI4sv
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
#define glVertexAttribI4sv(index,v) do { GLFuncPtrName(glVertexAttribI4sv)(index, v); GL_AUTOCHECK_BLOCK("glVertexAttribI4sv", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttribI4ubv
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
#define glVertexAttribI4ubv(index,v) do { GLFuncPtrName(glVertexAttribI4ubv)(index, v); GL_AUTOCHECK_BLOCK("glVertexAttribI4ubv", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttribI4usv
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
#define glVertexAttribI4usv(index,v) do { GLFuncPtrName(glVertexAttribI4usv)(index, v); GL_AUTOCHECK_BLOCK("glVertexAttribI4usv", __FILE__, __LINE__); } while(0)

/**
 *  @def glGetUniformuiv
 *  @brief Returns the value of a uniform variable
 *  @param[in] program Specifies the program object to be queried.
 *  @param[in] location Specifies the location of the uniform variable to be queried.
 *  @param[out] params Returns the value of the specified uniform variable.
 */
#define glGetUniformuiv(program,location,params) do { GLFuncPtrName(glGetUniformuiv)(program, location, params); GL_AUTOCHECK_BLOCK("glGetUniformuiv", __FILE__, __LINE__); } while(0)

/**
 *  @def glBindFragDataLocation
 *  @brief bind a user-defined varying out variable to a fragment shader color number
 *  @param[in] program The name of the program containing varying out variable whose binding to modify
 *  @param[in] colorNumber The color number to bind the user-defined varying out variable to
 *  @param[in] name The name of the user-defined varying out variable whose binding to modify
 */
#define glBindFragDataLocation(program,colorNumber,name) do { GLFuncPtrName(glBindFragDataLocation)(program, colorNumber, name); GL_AUTOCHECK_BLOCK("glBindFragDataLocation", __FILE__, __LINE__); } while(0)

/**
 *  @def glGetFragDataLocation
 *  @brief query the bindings of color numbers to user-defined varying out variables
 *  @param[in] program The name of the program containing varying out variable whose binding to query
 *  @param[in] name The name of the user-defined varying out variable whose binding to query
 */
#define glGetFragDataLocation(program,name) GLAutoCheckFuncPtrName(glGetFragDataLocation)(program, name GLAutoCheckExtraParams)

/**
 *  @def glUniform1ui
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform variable to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified uniform variable.
 */
#define glUniform1ui(location,v0) do { GLFuncPtrName(glUniform1ui)(location, v0); GL_AUTOCHECK_BLOCK("glUniform1ui", __FILE__, __LINE__); } while(0)

/**
 *  @def glUniform2ui
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform variable to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified uniform variable.
 *  @param[in] v1 Specifies the new values to be used for the specified uniform variable.
 */
#define glUniform2ui(location,v0,v1) do { GLFuncPtrName(glUniform2ui)(location, v0, v1); GL_AUTOCHECK_BLOCK("glUniform2ui", __FILE__, __LINE__); } while(0)

/**
 *  @def glUniform3ui
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform variable to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified uniform variable.
 *  @param[in] v1 Specifies the new values to be used for the specified uniform variable.
 *  @param[in] v2 Specifies the new values to be used for the specified uniform variable.
 */
#define glUniform3ui(location,v0,v1,v2) do { GLFuncPtrName(glUniform3ui)(location, v0, v1, v2); GL_AUTOCHECK_BLOCK("glUniform3ui", __FILE__, __LINE__); } while(0)

/**
 *  @def glUniform4ui
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform variable to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified uniform variable.
 *  @param[in] v1 Specifies the new values to be used for the specified uniform variable.
 *  @param[in] v2 Specifies the new values to be used for the specified uniform variable.
 *  @param[in] v3 Specifies the new values to be used for the specified uniform variable.
 */
#define glUniform4ui(location,v0,v1,v2,v3) do { GLFuncPtrName(glUniform4ui)(location, v0, v1, v2, v3); GL_AUTOCHECK_BLOCK("glUniform4ui", __FILE__, __LINE__); } while(0)

/**
 *  @def glUniform1uiv
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform value to be modified.
 *  @param[in] count Specifies the number of elements that are to be modified. This should be 1 if
 *      the targeted uniform variable is not an array, and 1 or more if it is an array.
 *  @param[in] value Specifies a pointer to an array of count values that will be used to update the
 *      specified uniform variable.
 */
#define glUniform1uiv(location,count,value) do { GLFuncPtrName(glUniform1uiv)(location, count, value); GL_AUTOCHECK_BLOCK("glUniform1uiv", __FILE__, __LINE__); } while(0)

/**
 *  @def glUniform2uiv
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform value to be modified.
 *  @param[in] count Specifies the number of elements that are to be modified. This should be 1 if
 *      the targeted uniform variable is not an array, and 1 or more if it is an array.
 *  @param[in] value Specifies a pointer to an array of count values that will be used to update the
 *      specified uniform variable.
 */
#define glUniform2uiv(location,count,value) do { GLFuncPtrName(glUniform2uiv)(location, count, value); GL_AUTOCHECK_BLOCK("glUniform2uiv", __FILE__, __LINE__); } while(0)

/**
 *  @def glUniform3uiv
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform value to be modified.
 *  @param[in] count Specifies the number of elements that are to be modified. This should be 1 if
 *      the targeted uniform variable is not an array, and 1 or more if it is an array.
 *  @param[in] value Specifies a pointer to an array of count values that will be used to update the
 *      specified uniform variable.
 */
#define glUniform3uiv(location,count,value) do { GLFuncPtrName(glUniform3uiv)(location, count, value); GL_AUTOCHECK_BLOCK("glUniform3uiv", __FILE__, __LINE__); } while(0)

/**
 *  @def glUniform4uiv
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform value to be modified.
 *  @param[in] count Specifies the number of elements that are to be modified. This should be 1 if
 *      the targeted uniform variable is not an array, and 1 or more if it is an array.
 *  @param[in] value Specifies a pointer to an array of count values that will be used to update the
 *      specified uniform variable.
 */
#define glUniform4uiv(location,count,value) do { GLFuncPtrName(glUniform4uiv)(location, count, value); GL_AUTOCHECK_BLOCK("glUniform4uiv", __FILE__, __LINE__); } while(0)

/**
 *  @def glTexParameterIiv
 *  @brief set texture parameters
 *  @param[in] target Specifies the target texture, which must be either GL_TEXTURE_1D,
 *      GL_TEXTURE_2D, GL_TEXTURE_3D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY,
 *      GL_TEXTURE_RECTANGLE, or GL_TEXTURE_CUBE_MAP.
 *  @param[in] pname Specifies the symbolic name of a texture parameter. pname can be one of the
 *      following: GL_TEXTURE_BASE_LEVEL, GL_TEXTURE_BORDER_COLOR, GL_TEXTURE_COMPARE_FUNC,
 *      GL_TEXTURE_COMPARE_MODE, GL_TEXTURE_LOD_BIAS, GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MAG_FILTER,
 *      GL_TEXTURE_MIN_LOD, GL_TEXTURE_MAX_LOD, GL_TEXTURE_MAX_LEVEL, GL_TEXTURE_SWIZZLE_R,
 *      GL_TEXTURE_SWIZZLE_G, GL_TEXTURE_SWIZZLE_B, GL_TEXTURE_SWIZZLE_A, GL_TEXTURE_SWIZZLE_RGBA,
 *      GL_TEXTURE_WRAP_S, GL_TEXTURE_WRAP_T, or GL_TEXTURE_WRAP_R.
 *  @param[in] params Specifies a pointer to an array where the value or values of pname are stored.
 */
#define glTexParameterIiv(target,pname,params) do { GLFuncPtrName(glTexParameterIiv)(target, pname, params); GL_AUTOCHECK_BLOCK("glTexParameterIiv", __FILE__, __LINE__); } while(0)

/**
 *  @def glTexParameterIuiv
 *  @brief set texture parameters
 *  @param[in] target Specifies the target texture, which must be either GL_TEXTURE_1D,
 *      GL_TEXTURE_2D, GL_TEXTURE_3D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY,
 *      GL_TEXTURE_RECTANGLE, or GL_TEXTURE_CUBE_MAP.
 *  @param[in] pname Specifies the symbolic name of a texture parameter. pname can be one of the
 *      following: GL_TEXTURE_BASE_LEVEL, GL_TEXTURE_BORDER_COLOR, GL_TEXTURE_COMPARE_FUNC,
 *      GL_TEXTURE_COMPARE_MODE, GL_TEXTURE_LOD_BIAS, GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MAG_FILTER,
 *      GL_TEXTURE_MIN_LOD, GL_TEXTURE_MAX_LOD, GL_TEXTURE_MAX_LEVEL, GL_TEXTURE_SWIZZLE_R,
 *      GL_TEXTURE_SWIZZLE_G, GL_TEXTURE_SWIZZLE_B, GL_TEXTURE_SWIZZLE_A, GL_TEXTURE_SWIZZLE_RGBA,
 *      GL_TEXTURE_WRAP_S, GL_TEXTURE_WRAP_T, or GL_TEXTURE_WRAP_R.
 *  @param[in] params Specifies a pointer to an array where the value or values of pname are stored.
 */
#define glTexParameterIuiv(target,pname,params) do { GLFuncPtrName(glTexParameterIuiv)(target, pname, params); GL_AUTOCHECK_BLOCK("glTexParameterIuiv", __FILE__, __LINE__); } while(0)

/**
 *  @def glGetTexParameterIiv
 *  @brief return texture parameter values
 *  @param[in] target Specifies the symbolic name of the target texture. GL_TEXTURE_1D,
 *      GL_TEXTURE_2D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY, GL_TEXTURE_3D,
 *      GL_TEXTURE_RECTANGLE, and GL_TEXTURE_CUBE_MAP are accepted.
 *  @param[in] pname Specifies the symbolic name of a texture parameter. GL_TEXTURE_BASE_LEVEL,
 *      GL_TEXTURE_BORDER_COLOR, GL_TEXTURE_COMPARE_MODE, GL_TEXTURE_COMPARE_FUNC,
 *      GL_TEXTURE_LOD_BIAS, GL_TEXTURE_MAG_FILTER, GL_TEXTURE_MAX_LEVEL, GL_TEXTURE_MAX_LOD,
 *      GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MIN_LOD, GL_TEXTURE_SWIZZLE_R, GL_TEXTURE_SWIZZLE_G,
 *      GL_TEXTURE_SWIZZLE_B, GL_TEXTURE_SWIZZLE_A, GL_TEXTURE_SWIZZLE_RGBA, GL_TEXTURE_WRAP_S,
 *      GL_TEXTURE_WRAP_T, and GL_TEXTURE_WRAP_R are accepted.
 *  @param[out] params Returns the texture parameters.
 */
#define glGetTexParameterIiv(target,pname,params) do { GLFuncPtrName(glGetTexParameterIiv)(target, pname, params); GL_AUTOCHECK_BLOCK("glGetTexParameterIiv", __FILE__, __LINE__); } while(0)

/**
 *  @def glGetTexParameterIuiv
 *  @brief return texture parameter values
 *  @param[in] target Specifies the symbolic name of the target texture. GL_TEXTURE_1D,
 *      GL_TEXTURE_2D, GL_TEXTURE_1D_ARRAY, GL_TEXTURE_2D_ARRAY, GL_TEXTURE_3D,
 *      GL_TEXTURE_RECTANGLE, and GL_TEXTURE_CUBE_MAP are accepted.
 *  @param[in] pname Specifies the symbolic name of a texture parameter. GL_TEXTURE_BASE_LEVEL,
 *      GL_TEXTURE_BORDER_COLOR, GL_TEXTURE_COMPARE_MODE, GL_TEXTURE_COMPARE_FUNC,
 *      GL_TEXTURE_LOD_BIAS, GL_TEXTURE_MAG_FILTER, GL_TEXTURE_MAX_LEVEL, GL_TEXTURE_MAX_LOD,
 *      GL_TEXTURE_MIN_FILTER, GL_TEXTURE_MIN_LOD, GL_TEXTURE_SWIZZLE_R, GL_TEXTURE_SWIZZLE_G,
 *      GL_TEXTURE_SWIZZLE_B, GL_TEXTURE_SWIZZLE_A, GL_TEXTURE_SWIZZLE_RGBA, GL_TEXTURE_WRAP_S,
 *      GL_TEXTURE_WRAP_T, and GL_TEXTURE_WRAP_R are accepted.
 *  @param[out] params Returns the texture parameters.
 */
#define glGetTexParameterIuiv(target,pname,params) do { GLFuncPtrName(glGetTexParameterIuiv)(target, pname, params); GL_AUTOCHECK_BLOCK("glGetTexParameterIuiv", __FILE__, __LINE__); } while(0)

/**
 *  @def glClearBufferiv
 *  @brief clear individual buffers of the currently bound draw framebuffer
 *  @param[in] buffer Specify the buffer to clear.
 *  @param[in] drawBuffer Specify a particular draw buffer to clear.
 *  @param[in] value For color buffers, a pointer to a four-element vector specifying R, G, B and A
 *      values to clear the buffer to. For depth buffers, a pointer to a single depth value to clear
 *      the buffer to. For stencil buffers, a pointer to a single stencil value to clear the buffer to.
 */
#define glClearBufferiv(buffer,drawBuffer,value) do { GLFuncPtrName(glClearBufferiv)(buffer, drawBuffer, value); GL_AUTOCHECK_BLOCK("glClearBufferiv", __FILE__, __LINE__); } while(0)

/**
 *  @def glClearBufferuiv
 *  @brief clear individual buffers of the currently bound draw framebuffer
 *  @param[in] buffer Specify the buffer to clear.
 *  @param[in] drawBuffer Specify a particular draw buffer to clear.
 *  @param[in] value For color buffers, a pointer to a four-element vector specifying R, G, B and A
 *      values to clear the buffer to. For depth buffers, a pointer to a single depth value to clear
 *      the buffer to. For stencil buffers, a pointer to a single stencil value to clear the buffer to.
 */
#define glClearBufferuiv(buffer,drawBuffer,value) do { GLFuncPtrName(glClearBufferuiv)(buffer, drawBuffer, value); GL_AUTOCHECK_BLOCK("glClearBufferuiv", __FILE__, __LINE__); } while(0)

/**
 *  @def glClearBufferfv
 *  @brief clear individual buffers of the currently bound draw framebuffer
 *  @param[in] buffer Specify the buffer to clear.
 *  @param[in] drawBuffer Specify a particular draw buffer to clear.
 *  @param[in] value For color buffers, a pointer to a four-element vector specifying R, G, B and A
 *      values to clear the buffer to. For depth buffers, a pointer to a single depth value to clear
 *      the buffer to. For stencil buffers, a pointer to a single stencil value to clear the buffer to.
 */
#define glClearBufferfv(buffer,drawBuffer,value) do { GLFuncPtrName(glClearBufferfv)(buffer, drawBuffer, value); GL_AUTOCHECK_BLOCK("glClearBufferfv", __FILE__, __LINE__); } while(0)

/**
 *  @def glClearBufferfi
 *  @brief clear individual buffers of the currently bound draw framebuffer
 *  @param[in] buffer Specify the buffer to clear.
 *  @param[in] drawBuffer Specify a particular draw buffer to clear.
 *  @param[in] depth The value to clear a depth render buffer to.
 *  @param[in] stencil The value to clear a stencil render buffer to.
 */
#define glClearBufferfi(buffer,drawBuffer,depth,stencil) do { GLFuncPtrName(glClearBufferfi)(buffer, drawBuffer, depth, stencil); GL_AUTOCHECK_BLOCK("glClearBufferfi", __FILE__, __LINE__); } while(0)

/**
 *  @def glGetStringi
 *  @brief return a string describing the current GL connection
 *  @param[in] name Specifies a symbolic constant, one of GL_VENDOR, GL_RENDERER, GL_VERSION, or
 *      GL_SHADING_LANGUAGE_VERSION. Additionally, glGetStringi accepts the GL_EXTENSIONS token.
 *  @param[in] index For glGetStringi, specifies the index of the string to return.
 */
#define glGetStringi(name,index) GLAutoCheckFuncPtrName(glGetStringi)(name, index GLAutoCheckExtraParams)

#endif // GL_VERSION_3_0

//                              --- ~OpenGL 3.0 ---

